
; NESwb_
	.inesprg 2
	.ineschr 4
	.inesmir 0
	.inesmap 4

FNC_WORK	.equ	$00 ; 12 bytes
FNC_ARG		.equ	$0c ;  8 bytes
MATH_REG	.equ	$14 ; 12 bytes
; for user $20 .. $9f
; free $a0 .. $bf
; for sound driver $c0 .. $ef
PPU_REG1	.equ	$f0
IRQ_LINE	.equ	$f1
SCROLL_X	.equ	$f2
SCROLL_Y	.equ	$f3
JOYPAD		.equ	$f4 ;  2 bytes
RAND		.equ	$f6 ;  2 bytes
VCMD_SIZE	.equ	$f8
SPR_UPD		.equ	$f9
;SYS_WORK	.equ	$fa
SUS_X		.equ	$fb
SUS_Y		.equ	$fc
SAVE_X		.equ	$fd
SAVE_Y		.equ	$fe
SYS_CNT		.equ	$ff

VCMD_DATA	.equ	$0100
VCMD_LIMIT	.equ	$01a0
STK_BASE	.equ	$01e0
SUS_WORK	.equ	$01e0 ; 20 bytes
VCMD_SEQ	.equ	$01f4
TSK_FNC		.equ	$01f6
FRM_FNC		.equ	$01f8
IRQ_FNC		.equ	$01fb
NMI_FNC		.equ	$01fe

SPR_DATA	.equ	$0200

; for sound driver $0300 .. $037f
; for user $0380 .. $07ff

JOY_UP		.equ	$10
JOY_DOWN	.equ	$20
JOY_RIGHT	.equ	$80
JOY_LEFT	.equ	$40
JOY_A		.equ	$01
JOY_B		.equ	$02
JOY_SELECT	.equ	$04
JOY_START	.equ	$08

	.include	"user_def.asm"

; vO
	.bank	0
	.org	$8000

	.bank	1
	.org	$a000

	.bank	2
	.org	$c000
	.include	"user_sub.asm"
	.org	$d000
	.include	"user_data.asm"

	.bank	3
	.org	$e000
	.include	"sound/bgm_field_polka_c.mls"
	.include	"sound/bgm_trepark_c.mls"
	.include	"sound/bgm_inadahime_c.mls"
	.include	"sound/se_vanish01c.mls"
	.include	"sound/se_vanish02c.mls"
	.include	"sound/se_vanish03c.mls"
	.include	"sound/se_vanish04c.mls"
	.include	"sound/se_vanish05c.mls"
	.include	"sound/se_vanish06c.mls"
	.include	"sound/se_vanish07c.mls"
	.include	"sound/se_vanish08c.mls"
	.include	"sound/se_vanish09c.mls"
	.include	"sound/se_vanish10c.mls"
	.include	"sound/se_vanish11c.mls"
	.include	"sound/se_vanish12c.mls"
	.include	"sound/se_vanish13c.mls"
	.include	"sound/se_vanish14c.mls"
	.include	"sound/se_vanish15c.mls"
	.include	"sound/se_vanish16c.mls"
	.include	"sound/se_vanish17c.mls"
	.include	"sound/se_vanish18c.mls"
	.include	"sound/se_vanish19c.mls"
	.include	"sound/se_vanish20c.mls"
	.include	"sound/se_miss1c.mls"
	.include	"sound/se_ready1c.mls"
	.include	"sound/se_timeup1c.mls"
	.include	"sound/bgm_field_polka_d.mls"
	.include	"sound/bgm_trepark_d.mls"
	.include	"sound/bgm_inadahime_d.mls"
	.include	"sound/se_vanish01d.mls"
	.include	"sound/se_vanish02d.mls"
	.include	"sound/se_vanish03d.mls"
	.include	"sound/se_vanish04d.mls"
	.include	"sound/se_vanish05d.mls"
	.include	"sound/se_vanish06d.mls"
	.include	"sound/se_vanish07d.mls"
	.include	"sound/se_vanish08d.mls"
	.include	"sound/se_vanish09d.mls"
	.include	"sound/se_vanish10d.mls"
	.include	"sound/se_vanish11d.mls"
	.include	"sound/se_vanish12d.mls"
	.include	"sound/se_vanish13d.mls"
	.include	"sound/se_vanish14d.mls"
	.include	"sound/se_vanish15d.mls"
	.include	"sound/se_vanish16d.mls"
	.include	"sound/se_vanish17d.mls"
	.include	"sound/se_vanish18d.mls"
	.include	"sound/se_vanish19d.mls"
	.include	"sound/se_vanish20d.mls"
	.include	"sound/se_miss1d.mls"
	.include	"sound/se_ready1d.mls"
	.include	"sound/se_timeup1d.mls"

	.org	$ea00
	.include	"user.asm"

;===============================

	; TEhhCo
	.org	$f000
	.include	"sound.asm"

	; Cu
	.org	$fa00
	.include	"math.asm"

	.org	$fc00
Int:
	.db	$00,$01,$02,$03,$04,$05,$06,$07
	.db	$08,$09,$0a,$0b,$0c,$0d,$0e,$0f
	.db	$10,$11,$12,$13,$14,$15,$16,$17
	.db	$18,$19,$1a,$1b,$1c,$1d,$1e,$1f
	.db	$20,$21,$22,$23,$24,$25,$26,$27
	.db	$28,$29,$2a,$2b,$2c,$2d,$2e,$2f
	.db	$30,$31,$32,$33,$34,$35,$36,$37
	.db	$38,$39,$3a,$3b,$3c,$3d,$3e,$3f
	.db	$40,$41,$42,$43,$44,$45,$46,$47
	.db	$48,$49,$4a,$4b,$4c,$4d,$4e,$4f
	.db	$50,$51,$52,$53,$54,$55,$56,$57
	.db	$58,$59,$5a,$5b,$5c,$5d,$5e,$5f
	.db	$60,$61,$62,$63,$64,$65,$66,$67
	.db	$68,$69,$6a,$6b,$6c,$6d,$6e,$6f
	.db	$70,$71,$72,$73,$74,$75,$76,$77
	.db	$78,$79,$7a,$7b,$7c,$7d,$7e,$7f
	.db	$80,$81,$82,$83,$84,$85,$86,$87
	.db	$88,$89,$8a,$8b,$8c,$8d,$8e,$8f
	.db	$90,$91,$92,$93,$94,$95,$96,$97
	.db	$98,$99,$9a,$9b,$9c,$9d,$9e,$9f
	.db	$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7
	.db	$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af
	.db	$b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7
	.db	$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf
	.db	$c0,$c1,$c2,$c3,$c4,$c5,$c6,$c7
	.db	$c8,$c9,$ca,$cb,$cc,$cd,$ce,$cf
	.db	$d0,$d1,$d2,$d3,$d4,$d5,$d6,$d7
	.db	$d8,$d9,$da,$db,$dc,$dd,$de,$df
	.db	$e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7
	.db	$e8,$e9,$ea,$eb,$ec,$ed,$ee,$ef
	.db	$f0,$f1,$f2,$f3,$f4,$f5,$f6,$f7
	.db	$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff

; ӁIvÖ̋󂫏Ȃ

	.org	$fd00

	; Vram]o^(񈳏k)
	; x p[^̃AhX(LOW)
	; y p[^̃AhX(HIGH)
	; p[^
	;   +0 f[^(byte)
	;   +1 tO(0x00:PPUAhX+1 0x04:PPUAhX+32)
	;   +2 PPUAhX(LOW)
	;   +3 PPUAhX(HIGH)
	;   +4 ]f[^AhX(LOW)
	;   +5 ]f[^AhX(HIGH)
Vcmd_SetData:
	.db	$a9	; lda #$a9

	; Vram]o^(k)
	; x p[^̃AhX(LOW)
	; y p[^̃AhX(HIGH)
	; p[^
	;   +0 kf[^(byte)
	;   +1 tO(0x00:PPUAhX+1 0x04:PPUAhX+32)
	;   +2 PPUAhX(LOW)
	;   +3 PPUAhX(HIGH)
	;   +4 kf[^AhX(LOW)
	;   +5 kf[^AhX(HIGH)
	; kf[^tH[}bg
	;   0yyyxxxx <value>...
	;   1vvvuuuu
	;     yyy  : JԂ-1
	;     xxxx : f[^-1(byte)
	;     vvv  : Qƈʒu(111:-1 .. 000:-8)
	;     uuuu : Rs[TCY-1(byte)
Vcmd_ExtractData:
	lda	#$18	; $a9 clc
	sta	<FNC_ARG+7

	lda	#6
	jsr	CopyToArg
.retry:
	ldy	<VCMD_SIZE
	sty	<FNC_WORK
	cpy	#LOW(VCMD_LIMIT-VCMD_DATA)
	bcs	.abort

	lda	<FNC_ARG
	sta	<FNC_WORK+1
	lda	<FNC_ARG+1
	and	#$0f
	sta	VCMD_DATA+1,y
	lda	<FNC_ARG+2
	sta	VCMD_DATA+3,y
	lda	<FNC_ARG+3
	sta	VCMD_DATA+2,y
	ldx	Int+4,y		; x <= y + 4
	ldy	#0

	lda	<FNC_ARG+7
	bpl	.ext

.set1:
	lda	[FNC_ARG+4],y
	iny
	sta	VCMD_DATA,x
	inx
	dec	<FNC_WORK+1
	bne	.set1

.finish:
	ldy	<FNC_WORK
	txa
	sec
	sbc	Int+4,y
	sta	VCMD_DATA,y

	; ݒ蒆Vram]sĂ蒼
	cpy	<VCMD_SIZE
	bne	.retry
	stx	<VCMD_SIZE
.abort:
	rts

.ext:
.ext1:
	lda	[FNC_ARG+4],y
	iny
	sty	<FNC_WORK+5
	tay
	and	#$0f
	sta	<FNC_WORK+3
	tya
	lsr	a
	lsr	a
	lsr	a
	lsr	a

	cmp	#$08
	bcs	.ext4

	sta	<FNC_WORK+2
.ext2:
	lda	<FNC_WORK+3
	sta	<FNC_WORK+4
	ldy	<FNC_WORK+5
.ext3:
	lda	[FNC_ARG+4],y
	iny
	sta	VCMD_DATA,x
	inx
	dec	<FNC_WORK+4
	bpl	.ext3
	dec	<FNC_WORK+2
	bpl	.ext2

	lda	<FNC_WORK+1
	clc
	sbc	<FNC_WORK+3
	sta	<FNC_WORK+1
.ext8:
	dec	<FNC_WORK+1
	bne	.ext1
	beq	.finish		; same as jmp

.ext4:
	ora	#$f0
	clc
	adc	Int,x
	tay
.ext5:
	lda	VCMD_DATA,y
	iny
	sta	VCMD_DATA,x
	inx
	dec	<FNC_WORK+3
	bpl	.ext5
	ldy	<FNC_WORK+5
	jmp	.ext8

	; Vram]o^(k)()
	; x p[^S擪̃AhX(LOW)
	; y p[^S擪̃AhX(HIGH)
	; Vcmd_ExtractDatãp[^
	; p[^̃tO̒ǉꂽ`͈ȉ̒ʂ
	; 0x80:p[^S̏ꎞf(ztO:0ŕA)
	; 0xc0:p[^S̏I[(ztO:1ŕA)
	; ꎞfꍇ͍ēxVcmd_SequenceDataĂԂƂ
	; ̏ĊJ
	; Yeild_EqƑgݍ킹邱Ƃŕt[ɕ
	; Vram]sƂo
Vcmd_SequenceData:
	lda	VCMD_SEQ+1
	beq	.1
	ldx	VCMD_SEQ
	tay
.1:
	stx	<FNC_WORK+8
	sty	<FNC_WORK+9
.2:
	ldx	<FNC_WORK+8
	ldy	<FNC_WORK+9
	jsr	Vcmd_ExtractData

	clc
	lda	<FNC_WORK+8
	adc	#6
	sta	<FNC_WORK+8
	bcc	.3
	inc	<FNC_WORK+9
.3:
	bit	<FNC_ARG+1	; Vcmd_ExtractDataœWJς݂
				; p[^Q
	bpl	.2

	ldx	<FNC_WORK+8
	lda	<FNC_WORK+9
	bvc	.9
	ldx	#$00
	txa
.9:
	stx	VCMD_SEQ
	sta	VCMD_SEQ+1
	rts

CopyToArg:
	stx	<FNC_ARG
	sty	<FNC_ARG+1
	tay
	dey
.1:
	lda	[FNC_ARG],y
	tax
	dey
	lda	[FNC_ARG],y
	stx	<FNC_ARG+1,y
	sta	FNC_ARG,y
	dey
	bpl	.1
	rts

	; [
	; `@gASY
	; 64927
	; RANDɊi[l͕sKǍDł邪
	; RAND+1Ɋi[l͒ʏ̐`@Ɠ
	; K藐ƂĂ͗pȂǂB
	; [`ďoAɂ͍XVRAND̒li[Ă
	; XVOƌRAND̒l͋֌W邽
	; Qo16bitlƂėpƒl̕΂肪B
	; Е̗bit0̗bit0xorȂǂ
	; us΁Ax΂gUłB
Rand:
	lda	<RAND
	bmi	.1
	lda	<RAND+1
	asl	a
	asl	a
	clc
	adc	<RAND+1
	clc
	adc	#123
	sta	<RAND+1
	lda	<RAND
.1
	asl	a
	asl	a
	clc
	adc	<RAND
	sec
	adc	<RAND+1
	sta	<RAND
Rand_Ret:			; FrameTaskԎ؂
	rts

FrameTask:
	; WCpbhԍXV
	lda	#$01
	sta	$4016
	lsr	a		; same as lda $00 & sec
	sta	$4016

	ror	a		; same as lda $80 & clc
	sta	<JOYPAD+1
.1:
	lda	$4016
	and	#$03
	cmp	#1
	ror	<JOYPAD
	lda	$4017
	and	#$03
	cmp	#1
	ror	<JOYPAD+1
	bcc	.1

	; XV
	jsr	Rand

	; TEhhCoXV
	jsr	SoundDriver_Update

	; [U`^XNĂяo
	lda	FRM_FNC+1
	beq	Rand_Ret	; RandretԎ؂
	jmp	[FRM_FNC]



; ӁIvÖ̋󂫏Ȃ
	.org	$fea0

	; VBlank҂ڍs[`S
	; Yeild          [U^XNVBlank҂Ɉڍs
	;                Yeild̎̈ʒuĊJ
	; Yeild_ReEntry  [U^XNVBlank҂Ɉڍs
	;                ĊJʒuݒ肹A͈ȑOݒ肵
	;                ʒu烆[U^XNĊJ
	; Yeild_Eq       ztO0̏ꍇYeild_ReEntry̓
	;                ztO1̏ꍇYeild̓
	; Yeild_SetEntry [U^XN̍ĊJʒuݒ肷
	;                VBlank҂ɈڍsA[U^XNp
Yeild_SetEntry:
	.db	$a0	; ldy #$a0
Yeild:
	ldy	#$18	; $a0 clc
	clc
	pla
	adc	#1
	sta	TSK_FNC
	pla
	adc	#0
	sta	TSK_FNC+1
	tya
	bpl	_ReEntry

	jmp	[TSK_FNC]

Yeild_Eq:
	beq	Yeild
Yeild_ReEntry:
	pla
	pla
_Yeild_Jmp:
	jmp	_ReEntry


Reset:
	; X^bN
	sei
	cld
	ldx	#LOW(STK_BASE-1)
	txs

	lda	#$00

	; oNZNg
	ldx	#$06
	stx	$8000
	tay		; same as ldy #$00
	sty	$8001	; set PRG ROM bank0 to 0x8000 .. 0x9fff
	inx		; same as ldx #$07
	stx	$8000
	iny		; same as ldy #$01
	sty	$8001	; set PRG ROM bank1 to 0xa000 .. 0xbfff

	; XN[It
;	lda	#$00
	sta	$2000
	sta	$2001

	; DMC荞ݐݒ
;	lda	#$00
	sta	$4010

	; VBlank҂
.1:
	bit	$2002
	bpl	.1

	; [N
	; sta $0000,x ` sta $0700,x ׂꍇƔׂ
	; 1.5{xAvOTCYȂ̂
	; y̏l𒲐邱ƂŏΏۊÕGA
	; ݒł邽ߌ̑
	; [y[W鎞ɂFNC_WORK+1̒l
	; 0ɂȂĂ邽߁AFNC_WORK+10ݒ肵Ă
	; s͐Ȃ
;	lda	#$00
;	ldx	#7		; oNZNgŎgpl𗬗p
	sta	<FNC_WORK
	stx	<FNC_WORK+1
	tay
.2:
	dey
	sta	[FNC_WORK],y
	bne	.2
	dec	<FNC_WORK+1
	bpl	.2

	; VBlank҂
.3:
	bit	$2002
	bpl	.3

	; ^XNǗ
	lda	#$4c		; jmp	$xxxx
	sta	IRQ_FNC-1
	sta	NMI_FNC-1

	; [U^XNݒ
	iny			; same as ldy #$01
.4:
	lda	TaskFunc,y
	sta	TSK_FNC,y
	dey
	bpl	.4

	; TEhhCo
	jsr	SoundDriver_Init

	lda	#$88
	sta	<PPU_REG1
	sta	$2000

_ReEntry:
;		ldx	#$1e
;		stx	$2001

	lda	<SYS_CNT
	cli
_MainLoop:
	cmp	<SYS_CNT
	beq	_MainLoop

;		inx		; same as ldx #$1f
;		stx	$2001

	; t[^XN̎s
	jsr	FrameTask

	; [U^XN
	jmp	[TSK_FNC]

VBlank:				; total:2273
	pha			; 3
	stx	<SAVE_X		; 3
	sty	<SAVE_Y		; 3

	; JE^XV
	inc	<SYS_CNT	; 5

	; IRQ荞ݐݒ(MMC3)
	lda	<IRQ_LINE	; 3
	beq	.1		; 2
	sta	$c000		; 4
	sta	$c001		; 4
	sta	$e001		; 4
.1:

	; XvCgf[^]
	lda	<SPR_UPD	; 3
	beq	.2		; 4
	lda	#$00		; 2
	sta	$2003		; 4
	ldx	#HIGH(SPR_DATA)	; 2
	stx	$4014		; 514 (+560/+38)
.2:
	; PPU]SP̑ޔƂSPR_UPDgp

	; PPU]
	ldx	<VCMD_SIZE		; 3
;	lda	#$00
	sta	VCMD_DATA,x		; 4
	tsx				; 2
	stx	<SPR_UPD		; 3
	ldx	#LOW(VCMD_DATA-1)	; 2
	txs				; 2 (+16)

	pla			; 4
	beq	.6		; 3
.3:
	lsr	a		; 2
	tax			; 2
	pla			; 4
	ora	<PPU_REG1	; 3
	sta	$2000		; 4
	pla			; 4
	sta	$2006		; 4
	pla			; 4
	sta	$2006		; 4
	bcc	.4		; 3 (+41)
	pla			; 4
	sta	$2007		; 4
	txa			; 2
	beq	.5		; 3 (+13)
.4:
	pla			; 4
	sta	$2007		; 4
	pla			; 4
	sta	$2007		; 4
	dex			; 2
	bne	.4		; 3 (+21)
.5:
	pla			; 4
	bne	.3		; 3
.6:
	ldx	<SPR_UPD	; 3
	txs			; 2
;	lda	#$00
	sta	<VCMD_SIZE	; 3

	; XvCgf[^]tO
	sta	<SPR_UPD

	; [U`^XNĂяo
	lda	NMI_FNC+1
	beq	.7
	jsr	NMI_FNC-1
.7:

	; XN[ʒuݒ
	lda	<SCROLL_X
	sta	$2005
	lda	<SCROLL_Y
	sta	$2005

	; VBlank荞݂̐ݒ
	lda	<PPU_REG1
	sta	$2000

	; TEhWX^XV
	jsr	SoundDriver_Reflect

	; [U^XNs(ip != $ffxx)̎
	; [U^XNꎞfAt[^XNs
	; t[^XNIAꎞf[U^XNɕA
	tsx
	lda	$0104,x
	ldy	<SAVE_Y
	ldx	<SAVE_X
	cmp	#$ff
	beq	.10

	sty	<SUS_Y
	stx	<SUS_X

	; FNC_WORK/FNC_ARG̑ޔ
	ldx	#$13
.8:
	lda	<FNC_WORK,x
	sta	SUS_WORK,x
	dex
	bpl	.8

	; t[^XN̎s
	cli
	jsr	FrameTask

	; FNC_WORK/FNC_ARG̕
	ldx	#$13
.9:
	lda	SUS_WORK,x
	sta	<FNC_WORK,x
	dex
	bpl	.9

	ldy	<SUS_Y
	ldx	<SUS_X
.10:
	pla
	rti

Irq:
	pha			; 3
	stx	<SAVE_X		; 3
	sty	<SAVE_Y		; 3

	; [U`^XNĂяo
	lda	IRQ_FNC+1	; 4
	beq	.1		; 2
	jsr	IRQ_FNC-1	; 6+3
.1:

	ldy	<SAVE_Y
	ldx	<SAVE_X
	pla
	rti

; ӁIvÖ̋󂫏Ȃ

	.org	$fff0
Bit:
	.db	$01,$02,$04,$08,$10,$20,$40,$80

	.org	$fff8
TaskFunc:
	.dw	User

	; 荞݃xN^[
	.org	$fffa
	.dw	VBlank
	.dw	Reset
	.dw	Irq

; OtBbNf[^`
	.bank	4
	.org	$0000

	.incbin "bg1.chr"
	.incbin "spr.chr"

	.bank	5
	.org	$0000

	.incbin "bg2.chr"

	.bank	6
	.org	$0000

	.bank	7
	.org	$0000

