	; ZCu

BCD_LowValue:
	.db	$01, $02, $04, $08, $0a, $14, $28, $50
	.db	$64, $c8, $90, $20, $e8, $d0, $a0, $40
	.db	$10, $20, $40, $80, $a0, $40, $80, $00
	.db	$40, $80, $00, $00, $80
BCD_MidValue:
	.db	$00, $00, $00, $00, $00, $00, $00, $00
	.db	$00, $00, $01, $03, $03, $07, $0f, $1f
	.db	$27, $4e, $9c, $38, $86, $0d, $1a, $35
	.db	$42, $84, $09, $12, $96
BCD_HighValue:
	.db	$00, $00, $00, $00, $00, $00, $00, $00
	.db	$00, $00, $00, $00, $00, $00, $00, $00
	.db	$00, $00, $00, $01, $01, $03, $06, $0c
	.db	$0f, $1e, $3d, $7a, $98

	; 1oCgli\iɕϊ
	; a                    : ϊl
	; FNC_ARG .. FNC_ARG+2 : ϊ(rbOGfBA)
Math_ByteToBCD:
	sta	<FNC_WORK
	lda	#$40

	ldx	#$ff
	ldy	#9
.1:
	inx
	sta	<FNC_ARG,x
.2:
	lda	<FNC_WORK
	sec
	sbc	BCD_LowValue,y
	bcc	.3
	sta	<FNC_WORK
.3:
	rol	<FNC_ARG,x
	lda	#$10
	dey
	bcc	.2
	bpl	.1
	rts

	; 2oCgli\iɕϊ
	; x                    : ϊl(L)
	; y                    : ϊl(H)
	; FNC_ARG .. FNC_ARG+4 : ϊ(rbOGfBA)
Math_WordToBCD:
	stx	<FNC_WORK
	sty	<FNC_WORK+1
	lda	#$20

	ldx	#$ff
	ldy	#18
.1:
	inx
	sta	<FNC_ARG,x
.2:
	lda	<FNC_WORK
	sec
	sbc	BCD_LowValue,y
	sta	<FNC_WORK+2
	lda	<FNC_WORK+1
	sbc	BCD_MidValue,y
	bcc	.3
	sta	<FNC_WORK+1
	lda	<FNC_WORK+2
	sta	<FNC_WORK
.3:
	rol	<FNC_ARG,x
	lda	#$10
	dey
	bcc	.2
	bpl	.1
	rts

	; MathReg̒l(3oCg)i\iɕϊ
	; x                    : ϊMathRegւ̃ItZbgl
	; FNC_ARG .. FNC_ARG+7 : ϊ(rbOGfBA)
Math_RegToBCD:
	lda	<MATH_REG,x
	sta	<FNC_WORK
	lda	<MATH_REG+1,x
	sta	<FNC_WORK+1
	lda	<MATH_REG+2,x
	sta	<FNC_WORK+2
	lda	#$80

	ldx	#$ff
	ldy	#28
.1:
	inx
	sta	<FNC_ARG,x
.2:
	lda	<FNC_WORK
	sec
	sbc	BCD_LowValue,y
	sta	<FNC_WORK+3
	lda	<FNC_WORK+1
	sbc	BCD_MidValue,y
	sta	<FNC_WORK+4
	lda	<FNC_WORK+2
	sbc	BCD_HighValue,y
	bcc	.3
	sta	<FNC_WORK+2
	lda	<FNC_WORK+3
	sta	<FNC_WORK
	lda	<FNC_WORK+4
	sta	<FNC_WORK+1
.3:
	rol	<FNC_ARG,x
	lda	#$10
	dey
	bcc	.2
	bpl	.1
	rts

	; MathReg̈ړ
	; x : ړMathRegւ̃ItZbgl
	; y : ړMathRegւ̃ItZbgl
Math_MoveReg:
	lda	MATH_REG,y
	sta	<MATH_REG,x
	lda	MATH_REG+1,y
	sta	<MATH_REG+1,x
	lda	MATH_REG+2,y
	sta	<MATH_REG+2,x
	rts

	; MathReg̉Z
	; x : MathRegւ̃ItZbgl
	; y : MathRegւ̃ItZbgl
Math_AddReg:
	clc
	lda	<MATH_REG,x
	adc	MATH_REG,y
	sta	<MATH_REG,x
	lda	<MATH_REG+1,x
	adc	MATH_REG+1,y
	sta	<MATH_REG+1,x
	lda	<MATH_REG+2,x
	adc	MATH_REG+2,y
	sta	<MATH_REG+2,x
	rts

	; MathReǧZ
	; x : 팸MathRegւ̃ItZbgl
	; y : MathRegւ̃ItZbgl
Math_SubReg:
	sec
	lda	<MATH_REG,x
	sbc	MATH_REG,y
	sta	<MATH_REG,x
	lda	<MATH_REG+1,x
	sbc	MATH_REG+1,y
	sta	<MATH_REG+1,x
	lda	<MATH_REG+2,x
	sbc	MATH_REG+2,y
	sta	<MATH_REG+2,x
	rts

	; MathReg̔r
	; x : 팸MathRegւ̃ItZbgl
	; y : MathRegւ̃ItZbgl
	;                        n z c
	; 800000-800000=000000 : 0 1 1
	; 800000-400000=400000 : 0 0 1
	; 800000-000000=800000 : 1 0 1
	; 400000-800000=c00000 : 1 0 0
	; 000000-800000=800000 : 1 0 0
	; 000000-c00000=400000 : 0 0 0
	; 008000-008000=000000 : 0 1 1
	; 008000-004000=004000 : 0 0 1
	; 008000-000000=008000 : 1 0 1
	; 004000-008000=ffc000 : 1 0 0
	; 000000-008000=ff8000 : 1 0 0
	; 000000-00c000=ff4000 : 1 0 0
	; 000080-000080=000000 : 0 1 1
	; 000080-000040=000040 : 0 0 1
	; 000080-000000=000080 : 1 0 1
	; 000040-000080=ffffc0 : 1 0 0
	; 000000-000080=ffff80 : 1 0 0
	; 000000-0000c0=ffff40 : 1 0 0
Math_CmpReg:
	lda	<MATH_REG+2,x
	cmp	MATH_REG+2,y
	bne	.2
	lda	<MATH_REG+1,x
	cmp	MATH_REG+1,y
	bne	.1
	lda	<MATH_REG,x
	cmp	MATH_REG,y
.1:
	bcs	.2
	lda	#$ff
.2:
	rts

	; MathReg̍Vtg
	; x : MathRegւ̃ItZbgl
	; y : Vtg
Math_AslReg1:
	ldy	#1
Math_AslReg:
	cpy	#0
	beq	.2
.1:
	asl	<MATH_REG,x
	rol	<MATH_REG+1,x
	rol	<MATH_REG+2,x
	dey
	bne	.1
.2:
	rts

	; MathReg̘_EVtg
	; x : MathRegւ̃ItZbgl
	; y : Vtg
Math_LsrReg1:
	ldy	#1
Math_LsrReg:
	cpy	#0
	beq	.2
.1:
	lsr	<MATH_REG+2,x
	ror	<MATH_REG+1,x
	ror	<MATH_REG,x
	dey
	bne	.1
.2:
	rts

	; MathReg̎ZpEVtg
	; x : MathRegւ̃ItZbgl
	; y : Vtg
Math_AsrReg1:
	ldy	#1
Math_AsrReg:
	cpy	#0
	beq	.2
	lda	<MATH_REG+2,x
	bpl	Math_LsrReg
.1:
	sec
	ror	<MATH_REG+2,x
	ror	<MATH_REG+1,x
	ror	<MATH_REG,x
	dey
	bne	.1
.2:
	rts

