	; TEhhCo

_SEQ_PTR	.equ	FNC_WORK    ; 2byte
_ENVTBL		.equ	FNC_WORK+2  ; 2byte
;_WORK3		.equ	FNC_WORK+4  ; 2byte
_CH_BIT		.equ	FNC_WORK+6
_CH_INX1	.equ	FNC_WORK+7
_WORK1		.equ	FNC_WORK+8  ; 2byte
_WORK2		.equ	FNC_WORK+10 ; 2byte

SND_STAT	.equ	$c0 ;  3 bytes
SND_REFFLG	.equ	$c3 ;  3 bytes
; SND_REFFLG+2bit7KEEP($f5)R}htOƂĎgp
; free $c6 .. $c7
SND_ECNT	.equ	$c8 ;  6 bytes
SND_EINX	.equ	$ce ;  6 bytes
SND_VCNT	.equ	$d4 ;  6 bytes
SND_VACC	.equ	$da ;  6 bytes
SND_NCNT	.equ	$e0 ; 16 bytes

SND_SEQ		.equ	$0300 ; 2x8 bytes
SND_KEYON	.equ	$0310 ;   8 bytes
SND_LENTBL	.equ	$0318 ; 2x2 bytes
SND_ENVTBL	.equ	$031c ; 2x2 bytes
SND_REG1	.equ	$0320 ;   8 bytes
SND_REG2	.equ	$0328 ;   8 bytes
SND_LCNT	.equ	$0330 ; 2x8 bytes
SND_TBASE	.equ	$0340 ;   8 bytes
SND_LBASE	.equ	$0348 ;   8 bytes
SND_EBASE	.equ	$0350 ;   8 bytes
; free $0358 .. $035b
SND_TREG	.equ	$035c ;  20 bytes
; free $0370 .. $037f

	; TEhhCo
SoundDriver_Init:
	lda	#$40
	sta	$4017	; disable frame interrupt

	lda	#$00
	ldx	#$30
.loop1:
	sta	<SND_STAT-1,x
	dex
	bne	.loop1

;	lda	#$00
	ldx	#$18
.loop2:
	sta	SND_SEQ-1,x
	dex
	bne	.loop2

	ldx	#(.data_end-.data)
.loop3:
	lda	.data-1,x
	sta	SND_LENTBL-1,x
	dex
	bne	.loop3
	rts
.data:
	.dw	Sound_LenTable, Sound_LenTable
	.dw	Sound_EnvTable, Sound_EnvTable
.data_end:

	; TEhhCo[BGMt
SoundDriver_PlayBGM_Ex:
	clc
	jsr	SoundDriver_TransArg
SoundDriver_PlayBGM:
	sta	<SND_STAT
	lda	#$00
	ldx	#7
.1:
	sta	<SND_NCNT,x
	sta	SND_LCNT,x
	dex
	bpl	.1
	ldx	#3
.2:
	sta	SND_KEYON,x
	sta	SND_EBASE,x
	dex
	bpl	.2
	rts

	; TEhhCo[SEt
SoundDriver_PlaySE_Ex:
	sec
	jsr	SoundDriver_TransArg
SoundDriver_PlaySE:
	sta	<SND_STAT+1
	lda	#$00
	ldx	#7
.1:
	sta	<SND_NCNT+8,x
	sta	SND_LCNT+8,x
	dex
	bpl	.1
	ldx	#3
.2:
	sta	SND_KEYON+4,x
	sta	SND_EBASE+4,x
	dex
	bpl	.2
	rts

SoundDriver_TransArg:
	stx	<FNC_WORK
	sty	<FNC_WORK+1
	ldy	#0
	lda	[FNC_WORK],y
	and	#$0f
	sta	<FNC_WORK+2
	sta	<FNC_WORK+3
	iny
	iny

	ldx	#0
	bcc	.1
	ldx	#2
.1:
	lda	[FNC_WORK],y
	sta	SND_LENTBL,x
	iny
	lda	[FNC_WORK],y
	sta	SND_LENTBL+1,x
	iny
	lda	[FNC_WORK],y
	sta	SND_ENVTBL,x
	iny
	lda	[FNC_WORK],y
	sta	SND_ENVTBL+1,x
	iny

	bcc	.4
	ldx	#8
	bcs	.4	; same as jmp
.2:
	lda	[FNC_WORK],y
	sta	SND_SEQ,x
	iny
	lda	[FNC_WORK],y
	sta	SND_SEQ+1,x
	iny
.3:
	inx
	inx
.4:
	lsr	<FNC_WORK+3
	bcs	.2
	bne	.3

	lda	<FNC_WORK+2
	rts

	; TEhhCo[BGMt~
SoundDriver_StopBGM:
	lda	#$00
	sta	<SND_STAT
	lda	<SND_STAT+1
	sta	<SND_STAT+2
	rts

	; TEhhCo[SEt~
SoundDriver_StopSE:
	lda	#$00
	sta	<SND_STAT+1
	lda	<SND_STAT
	sta	<SND_STAT+2
	rts

	; TEhhCoXV
SoundDriver_Update:
	; rbgtOƃCfbNX̏
	ldy	#$00
	sty	<_CH_INX1
.main_1:
	ldx	Sound_ToPrio2,y
	lda	SND_ENVTBL,x
	sta	<_ENVTBL
	lda	SND_ENVTBL+1,x
	sta	<_ENVTBL+1
	lda	#$01
	sta	<_CH_BIT
.main_2:
	; V[PX
	ldx	Sound_ToPrio1,y
	lda	<SND_STAT,x
	and	<_CH_BIT
	beq	.main_5

	ldx	Sound_ToX2,y
	lda	<SND_NCNT+1,x
	bmi	.main_3
	ora	<SND_NCNT,x
	bne	.main_4
.main_3:
	jsr	.setup
.main_4:
	jsr	.envelope

;	ldy	<_CH_INX1
	ldx	Sound_ToX2,y
	sec
	lda	<SND_NCNT,x
	sbc	#4
	sta	<SND_NCNT,x
	lda	<SND_NCNT+1,x
	sbc	#0
	sta	<SND_NCNT+1,x
.main_5:

	; rbgtOƃCfbNX̍XV
	asl	<_CH_BIT
	inc	<_CH_INX1
	ldy	<_CH_INX1
	cpy	#4
	beq	.main_1
	cpy	#8
	bne	.main_2

	rts

	; /xR}h̏(L[It)
.note_off:
	eor	#$ff
	sta	<_WORK1
	ldy	<_CH_INX1

	lda	#$00
	sta	<_WORK2+1
	ldx	Sound_ToPrio2,y
	lda	SND_LBASE,y
	asl	a
	rol	<_WORK2+1
	asl	a
	rol	<_WORK2+1
;	clc
	adc	SND_LENTBL,x
	sta	<_WORK2
	lda	<_WORK2+1
	adc	SND_LENTBL+1,x
	sta	<_WORK2+1

	ldx	Sound_ToX2,y
	lda	<_WORK1
	and	#$f0
	lsr	a
	lsr	a
	tay
	iny
	iny
;	clc
	lda	<SND_NCNT,x
	adc	[_WORK2],y
	sta	<SND_NCNT,x
	iny
	lda	<SND_NCNT+1,x
	adc	[_WORK2],y
	sta	<SND_NCNT+1,x

	ldy	<_CH_INX1
	lda	Sound_ToPrio1,y
	bne	.note_off_1

	lda	<SND_STAT+1
	and	<_CH_BIT
	bne	.note_off_4

.note_off_1:
	ldx	Sound_ToEnv,y
	bmi	.note_off_3
	lda	<SND_VCNT,x
	beq	.note_off_2

	lda	SND_EBASE,y
	tay
	lda	[_ENVTBL],y
	and	#$0f
	beq	.note_off_2
	tay
	lda	Sound_ReleaseRate,y
	sta	<SND_VACC,x
	jmp	.note_off_4

.note_off_2:
	; ̏
	lda	#$00
	sta	<SND_VCNT,x
.note_off_3:
	lda	<_CH_BIT
	eor	#$ff
	and	<SND_STAT+2
	sta	<SND_STAT+2

.note_off_4:
	ldy	<_CH_INX1
	lda	#$00
	sta	SND_KEYON,y
	jmp	.end

.setup:
	; V[PX|C^[N̈ɃRs[
	ldx	<_CH_INX1
	ldy	Sound_ToX2,x
	lda	SND_SEQ,y
	sta	<_SEQ_PTR
	lda	SND_SEQ+1,y
	sta	<_SEQ_PTR+1

.seq:
	; /xR}h̃L[It̔
	ldx	<_CH_INX1
	lda	SND_KEYON,x
	beq	.seq_1
	jmp	.note_off
.seq_1:
	; V[PX|C^̎w悩R}hǂݍ
	ldy	#$00
	lda	[_SEQ_PTR],y

	; I[R}h̔
	cmp	#$ff
	beq	.cmd_term

	; V[PX|C^i߂
	inc	<_SEQ_PTR
	bne	.seq_2
	inc	<_SEQ_PTR+1
.seq_2:
	; /xR}h̔
	cmp	#$f0
	bcc	.note_on

	; R}h̕
	and	#$0f
	asl	a
	tay
	lda	.jmptbl+1,y
	pha
	lda	.jmptbl,y
	pha

	cpy	#$1c	; KEEP($fe)R}hȍ~
	bcs	.seq_3

	; ̃V[PXǂݍ
	ldy	#$00
	lda	[_SEQ_PTR],y

	; V[PX|C^i߂
	inc	<_SEQ_PTR
	bne	.seq_3
	inc	<_SEQ_PTR+1
.seq_3:
	; jmp
	rts

	; V[PX̏I[
.cmd_term:
	ldy	<_CH_INX1
	ldx	Sound_ToPrio1,y
	lda	<SND_STAT,x
	eor	<_CH_BIT
	sta	<SND_STAT,x

	cpx	#0
	beq	.cmd_term2

	lda	<_CH_BIT
	eor	#$ff
	and	<SND_STAT+2
	sta	<SND_STAT+2

	ldx	Sound_ToLow,y
	lda	SND_REG1,x
	sta	SND_TREG,x
	lda	SND_REG2,x
	sta	SND_TREG+4,x
	lda	<SND_REFFLG
	ora	Bit,x
	ora	Bit+4,x
	sta	<SND_REFFLG

	txa
	tay
	lda	SND_KEYON,x
	beq	.cmd_term1

	eor	#$ff
	and	#$0f
	beq	.cmd_term1

	jsr	.key_on

.cmd_term1:
	jmp	.end

.cmd_term2:
	lda	<_CH_BIT
	bit	<SND_STAT+1
	beq	.cmd_term3

	eor	#$ff
	and	<SND_STAT+2
	sta	<SND_STAT+2
.cmd_term3:
	jmp	.end

	; /xR}h̏(L[I)
.note_on:
	sta	<_WORK1
	ldy	<_CH_INX1
	eor	#$ff
	sta	SND_KEYON,y

	lda	#$00
	sta	<_WORK2+1
	ldx	Sound_ToPrio2,y
	lda	SND_LBASE,y
	asl	a
	rol	<_WORK2+1
	asl	a
	rol	<_WORK2+1
;	clc
	adc	SND_LENTBL,x
	sta	<_WORK2
	lda	<_WORK2+1
	adc	SND_LENTBL+1,x
	sta	<_WORK2+1

	ldx	Sound_ToX2,y
	lda	<_WORK1
	and	#$f0
	lsr	a
	lsr	a
	tay
;	clc
	lda	<SND_NCNT,x
	adc	[_WORK2],y
	sta	<SND_NCNT,x
	iny
	lda	<SND_NCNT+1,x
	adc	[_WORK2],y
	sta	<SND_NCNT+1,x
	iny
	lda	[_WORK2],y
	iny
	ora	[_WORK2],y
	ldy	<_CH_INX1
	tax		; same as cmp #0
	bne	.note_on_1
	lda	#$00
	sta	SND_KEYON,y
.note_on_1:

	lda	Sound_ToPrio1,y
	bne	.note_on_2

	lda	<SND_STAT+1
	and	<_CH_BIT
	bne	.note_on_3

.note_on_2:
	lda	<SND_REFFLG+2	; KEEPR}htO̔
	bmi	.note_on_3

	lda	<_WORK1
	and	#$0f
	bne	.note_on_4

	; x̏
	lda	<_CH_BIT
	eor	#$ff
	and	<SND_STAT+2
	sta	<SND_STAT+2

	ldx	Sound_ToEnv,y
	bmi	.note_on_3
	lda	#$00
	sta	<SND_VCNT,x
.note_on_3:
	jmp	.end

.note_on_4:
	; ̏
	jsr	.key_on

	ldy	<_CH_INX1
	ldx	Sound_ToEnv,y
	bmi	.note_on_5

	lda	SND_EBASE,y
	tay
	lda	[_ENVTBL],y
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	sta	<_WORK1
	iny
	lda	[_ENVTBL],y
	and	#$f0
	lsr	a
	lsr	a
	sta	<SND_ECNT,x
	iny
	sty	<SND_EINX,x

	lda	#$ff
	sta	<SND_VCNT,x
	ldy	<_WORK1
	lda	Sound_SustainRate,y
	sta	<SND_VACC,x

.note_on_5:
	jmp	.end

.key_on:
	clc
	adc	SND_TBASE,y
	cpy	#$03
	beq	.key_on_1
	cpy	#$07
	beq	.key_on_1

	asl	a
	tax
	lda	Sound_KeyTable-2,x
	sta	<_WORK2
	lda	Sound_KeyTable-1,x
	ora	#$08
	sta	<_WORK2+1
	bcc	.key_on_2	; same as jmp

.key_on_1:
	sec
	sbc	#$10
	and	#$8f
	sta	<_WORK2
	lda	#$08
	sta	<_WORK2+1

.key_on_2:
	ldx	Sound_ToLow,y
	lda	SND_REG1,y
	sta	SND_TREG,x
	lda	<_WORK2
	sta	SND_TREG+8,x
	lda	<_WORK2+1
	sta	SND_TREG+12,x
	lda	<SND_REFFLG
	ora	Bit,x
	sta	<SND_REFFLG
	lda	<SND_REFFLG+1
	ora	Bit,x
	ora	Bit+4,x
	sta	<SND_REFFLG+1

	lda	<SND_STAT+2
	ora	<_CH_BIT
	sta	<SND_STAT+2

	rts

.jmptbl:
	.dw	.cmd_reg1-1
	.dw	.cmd_reg2-1
	.dw	.cmd_tbase-1
	.dw	.cmd_lbase-1
	.dw	.cmd_ebase-1
	.dw	.seq-1
	.dw	.seq-1
	.dw	.seq-1
	.dw	.seq-1
	.dw	.seq-1
	.dw	.cmd_rep_short-1
	.dw	.cmd_rep_long-1
	.dw	.cmd_jmp-1
	.dw	.seq-1
	.dw	.cmd_keep-1

	; WX^1ݒR}h
.cmd_reg1:
;	ldx	<_CH_INX1
	sta	SND_REG1,x
	cpx	#4
	bcs	.cmd_reg1_1

	tay
	lda	<SND_STAT+1
	and	<_CH_BIT
	bne	.cmd_reg1_2
	tya

.cmd_reg1_1:
	ldy	Sound_ToLow,x
	sta	SND_TREG,y
	lda	<SND_REFFLG
	ora	Bit,y
	sta	<SND_REFFLG
.cmd_reg1_2:
	jmp	.seq

	; WX^2ݒR}h
.cmd_reg2:
;	ldx	<_CH_INX1
	sta	SND_REG2,x
	cpx	#4
	bcs	.cmd_reg2_1

	tay
	lda	<SND_STAT+1
	and	<_CH_BIT
	bne	.cmd_reg2_2
	tya

.cmd_reg2_1:
	ldy	Sound_ToLow,x
	sta	SND_TREG+4,y
	lda	<SND_REFFLG
	ora	Bit+4,y
	sta	<SND_REFFLG
.cmd_reg2_2:
	jmp	.seq

	; x[XݒR}h
.cmd_tbase:
;	ldx	<_CH_INX1
	sta	SND_TBASE,x
	jmp	.seq

	; x[XݒR}h
.cmd_lbase:
;	ldx	<_CH_INX1
	sta	SND_LBASE,x
	jmp	.seq

	; Gx[vx[XݒR}h
.cmd_ebase:
;	ldx	<_CH_INX1
	sta	SND_EBASE,x
	jmp	.seq

	; KEEPR}h
.cmd_keep:
	lda	SND_REFFLG+2
	ora	#$80
	sta	SND_REFFLG+2
	jmp	.seq

	; s[gR}h(V[g`)
.cmd_rep_short:
;	ldx	<_CH_INX1
	stx	<_WORK2
	lsr	a
	rol	<_WORK2
	tax
	and	#$03
	adc	#2
	sta	<_WORK1
	txa
	lsr	a
	lsr	a
	ora	#$e0
	sta	<_WORK1+1

	jmp	.cmd_rep_long_1

	; s[gR}h(O`)
.cmd_rep_long:
;	ldx	<_CH_INX1
	stx	<_WORK2
	lsr	a
	rol	<_WORK2
	sta	<_WORK1

	; ̃V[PXǂݍ
;	ldy	#$00
	lda	[_SEQ_PTR],y
	sta	<_WORK1+1

	; V[PX|C^i߂
	inc	<_SEQ_PTR
	bne	.cmd_rep_long_1
	inc	<_SEQ_PTR+1
.cmd_rep_long_1:

	; [vJE^mF
	; 0:[v 0ȊO:[v
	ldx	_WORK2
	lda	SND_LCNT,x
	bne	.cmd_rep_long_2

	; [v̏
	lda	<_WORK1
	sta	SND_LCNT,x

.cmd_rep_long_2:
	dec	SND_LCNT,x
	beq	.cmd_rep_long_3

	; V[PX|C^ɔѐ܂ł̋Z
	clc
	lda	<_SEQ_PTR
	adc	<_WORK1+1
	sta	<_SEQ_PTR
	lda	<_SEQ_PTR+1
	adc	#$ff
	sta	<_SEQ_PTR+1
.cmd_rep_long_3:
	jmp	.seq

	; WvR}h
.cmd_jmp:
	asl	a
	bcs	.cmd_jmp_1

	; V[g`
	cmp	#$80
	ror	a
	sta	<_WORK1
	cmp	#$80
	sbc	<_WORK1
	eor	#$ff
	sta	<_WORK1+1
	jmp	.cmd_jmp_2

	; O`
.cmd_jmp_1:
	sta	<_WORK1

	; ̃V[PXǂݍ
;	ldy	#$00
	lda	[_SEQ_PTR],y
	cmp	#$80
	ror	a
	sta	<_WORK1+1
	ror	<_WORK1

	; V[PX|C^i߂
	inc	<_SEQ_PTR
	bne	.cmd_jmp_2
	inc	<_SEQ_PTR+1
.cmd_jmp_2:

	; V[PX|C^ɔѐ܂ł̋Z
	clc
	lda	<_SEQ_PTR
	adc	<_WORK1
	sta	<_SEQ_PTR
	lda	<_SEQ_PTR+1
	adc	<_WORK1+1
	sta	<_SEQ_PTR+1
	jmp	.seq

.end:
	; V[PX|C^̏߂
	ldy	<_CH_INX1
	ldx	Sound_ToX2,y
	lda	<_SEQ_PTR
	sta	SND_SEQ,x
	lda	<_SEQ_PTR+1
	sta	SND_SEQ+1,x

	; KEEPR}htO
	lda	<SND_REFFLG+2
	and	#$7f
	sta	<SND_REFFLG+2

	rts

	; Gx[v
.envelope:
;	ldy	<_CH_INX1
	ldx	Sound_ToEnv,y
	bmi	.envelope_3
	lda	<SND_VCNT,x
	beq	.envelope_3
	sec
	sbc	<SND_VACC,x
	bcs	.envelope_1
	lda	#$00
.envelope_1:
	sta	<SND_VCNT,x
	sta	<_WORK1

	lda	Sound_ToPrio1,y
	bne	.envelope_2
	lda	<_CH_BIT
	and	<SND_STAT+1
	bne	.envelope_3
.envelope_2:
	lda	<_WORK1
	bne	.envelope_4

	; ̏
	lda	<_CH_BIT
	eor	#$ff
	and	<SND_STAT+2
	sta	<SND_STAT+2
.envelope_3:
	rts

.envelope_4:
	; ʂ̐ݒ
	lsr	a
	and	#$f0
	sta	<_WORK1
	lda	SND_REG1,y
	and	#$0f
	ora	<_WORK1
	tax
	lda	Sound_MulTable,x
	tax
	lda	Sound_AddSatTable+8,x
	sta	<_WORK1

	ldx	Sound_ToEnv,y
	lda	<SND_ECNT,x
	bne	.envelope_5

	lda	SND_EBASE,y
	tay
	iny
	lda	[_ENVTBL],y
	sta	<_WORK1+1
	and	#$0f
	beq	.envelope_6
	asl	a
	asl	a
	sta	<SND_ECNT,x
	lda	<_WORK1+1
	and	#$f0
	lsr	a
	lsr	a
	sta	<_WORK1+1
	iny
	tya
	adc	<_WORK1+1
	sta	<SND_EINX,x

.envelope_5:
	ldy	<SND_EINX,x
	lda	[_ENVTBL],y
	sta	<_WORK1+1
	and	#$f0
	ora	<_WORK1
	tax
	lda	Sound_MulTable,x
	sta	<_WORK1
	lda	<_WORK1+1
	and	#$0f
	clc
	adc	<_WORK1
	tax
	lda	Sound_AddSatTable,x
	sta	<_WORK1

	ldy	<_CH_INX1
	ldx	Sound_ToEnv,y
	inc	<SND_EINX,x
	dec	<SND_ECNT,x

.envelope_6:
	ldy	<_CH_INX1
	lda	SND_REG1,y
	and	#$f0
	ora	<_WORK1
	ldx	Sound_ToLow,y
	sta	SND_TREG,x
	lda	<SND_REFFLG
	ora	Bit,x
	sta	<SND_REFFLG
	rts

SoundDriver_Reflect:
	; Đ`l̐ݒ(WX^ݒ)
	lda	<SND_STAT
	ora	<SND_STAT+1
	sta	$4015

	; APUWX^ւ̔f1
	ldx	#$00
	beq	.3	; same as jmp
.1:
	ldy	Sound_ToReflect,x
	lda	SND_TREG,x
	sta	$4000,y
.2:
	inx
.3:
	lsr	<SND_REFFLG
	bcs	.1
	bne	.2

	; APUWX^ւ̔f2
	ldx	#$08
	bne	.6	; same as jmp
.4:
	ldy	Sound_ToReflect,x
	lda	SND_TREG,x
	sta	$4000,y
.5:
	inx
.6:
	lsr	<SND_REFFLG+1
	bcs	.4
	bne	.5

	; APUWX^ւ̔f3
	ldx	#$10
	bne	.9	; same as jmp
.7:
	ldy	Sound_ToReflect,x
	lda	SND_TREG,x
	sta	$4000,y
.8:
	inx
.9:
	lsr	<SND_REFFLG+2
	bcs	.7
	bne	.8

	; Đ`l̐ݒ(x)
	lda	<SND_STAT+2
	sta	$4015
	rts

Sound_DataTable:
.align1:
	.org	(HIGH(.align1-65)+1)*256+104
Sound_LenTable:
	.dw	  4,   0,   8,   0,  12,   0,  15,   0
	.dw	 20,   0,  30,   0,  40,   0,  45,   0
	.dw	 60,   0,  90,   0, 120,   0, 180,   0
	.dw	240,   0, 360,   0, 480,   0
	.dw	  4,   0,   8,   0,  12,   0,  15,   0
	.dw	 16,   4,  16,  14,  24,  16,  29,  16
	.dw	 44,  16,  74,  16, 104,  16, 164,  16
	.dw	224,  16, 344,  16, 464,  16
Sound_ToX2:
	.db	 0,  2,  4,  6,  8, 10, 12, 14
Sound_ToLow:
	.db	 0,  1,  2,  3,  0,  1,  2,  3
Sound_ToPrio1:
	.db	 0,  0,  0,  0,  1,  1,  1,  1
Sound_ToPrio2:
	.db	 0,  0,  0,  0,  2,  2,  2,  2

.align2:
	.org	(HIGH(.align2-1)+1)*256
Sound_ToEnv:
	.db	 0,  1,255,  2,  3,  4,255,  5
Sound_ToReflect:
	.db	 0,  4,  8, 12,  1,  5,  9, 13
	.db	 2,  6, 10, 14,  3,  7, 11, 15
	.db	16, 17, 18, 19

Sound_KeyTable:
	.dw	1710, 1614, 1524, 1438, 1357, 1281
	.dw	1209, 1141, 1077, 1017,  960,  906
	.dw	 855,  807,  762,  719,  679,  641
	.dw	 605,  571,  539,  508,  480,  453
	.dw	 428,  404,  381,  360,  339,  320
	.dw	 302,  285,  269,  254,  240,  226
	.dw	 214,  202,  190,  180,  170,  160
	.dw	 151,  143,  135,  127,  120,  113
	.dw	 107,  101,   95,   90,   85,   80
	.dw	  76,   71,   67,   64,   60,   57
	.dw	  53,   50,   48,   45,   42,   40
	.dw	  38,   36,   34,   32,   30,   28

Sound_SustainRate:
	.db	$00, $01, $02, $03, $04, $05, $06, $07
	.db	$08, $09, $0a, $0c, $0e, $10, $12, $14
Sound_ReleaseRate:
	.db	$ff, $80, $55, $40, $2a, $20, $17, $12
	.db	$10, $0d, $0a, $08, $06, $04, $02, $01

Sound_EnvTable:
;	.db	$00, $00
Sound_AddSatTable:
	.db	 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 3, 4, 5, 6, 7
	.db	 8, 9,10,11,12,13,14,15,15,15,15,15,15,15,15,15
	.db	15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15

.align3:
	.org	(HIGH(.align3-1)+1)*256
Sound_MulTable:
	.db	0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2
	.db	0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4
	.db	0, 0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6
	.db	0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8
	.db	0, 1, 1, 2, 3, 3, 4, 4, 5, 6, 6, 7, 8, 8, 9, 9
	.db	0, 1, 2, 2, 3, 4, 5, 5, 6, 7, 8, 8, 9,10,11,11
	.db	0, 1, 2, 3, 4, 4, 5, 6, 7, 8, 9,10,11,11,12,13
	.db	0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
	.db	0, 1, 2, 3, 5, 6, 7, 8, 9,10,11,12,14,15,16,17
	.db	0, 1, 3, 4, 5, 6, 8, 9,10,11,13,14,15,16,18,19
	.db	0, 1, 3, 4, 6, 7, 8,10,11,12,14,15,17,18,19,21
	.db	0, 2, 3, 5, 6, 8, 9,11,12,14,15,17,18,20,21,23
	.db	0, 2, 3, 5, 7, 8,10,11,13,15,16,18,20,21,23,24
	.db	0, 2, 4, 5, 7, 9,11,12,14,16,18,19,21,23,25,26
	.db	0, 2, 4, 6, 8, 9,11,13,15,17,19,21,23,24,26,28
	.db	0, 2, 4, 6, 8,10,12,14,16,18,20,22,24,26,28,30

