; [U^XN(C)

	; 
User:
	; XN[It
	lda	#$00
	sta	$2001

	; ~[O
;	lda	#$00	; ~[O
	sta	$a000

	; oN؂ւ
	ldx	#$02
	stx	$8000
	ldy	#$04
	sty	$8001	; set CHR ROM bank2 to 0x1000 .. 0x13ff
	inx		; same as ldx #$03
	stx	$8000
	iny		; same as ldy #$05
	sty	$8001	; set CHR ROM bank2 to 0x1400 .. 0x17ff
	inx		; same as ldx #$04
	stx	$8000
	iny		; same as ldy #$06
	sty	$8001	; set CHR ROM bank3 to 0x1400 .. 0x17ff
	inx		; same as ldx #$05
	stx	$8000
	iny		; same as ldy #$07
	sty	$8001	; set CHR ROM bank3 to 0x1400 .. 0x17ff

	; [hݒ
	lda	<PPU_REG1
	ora	#$30	; XvCg 8x16
	sta	<PPU_REG1

	; pbg
	lda	#$40
	jsr	Vcmd_SetPalette

	; XN[ݒ
	lda	#$08
	sta	<SCROLL_X
	sta	<SCROLL_Y

	; NMI^XNݒ
	lda	#LOW(User_Nmi)
	sta	NMI_FNC
	lda	#HIGH(User_Nmi)
	sta	NMI_FNC+1

	; IRQ^XNݒ
	lda	#LOW(User_Irq_Title)
	sta	IRQ_FNC
	lda	#HIGH(User_Irq_Title)
	sta	IRQ_FNC+1
	lda	#39
	sta	<IRQ_LINE

	; ϐ
	lda	#$00
	sta	<JOY_PREV	; Pt[O̓͏
	lda	#$01
	sta	<CUR_BGM
	sta	<CUR_SE
	lda	#16
	sta	<JOY_CNT
	sta	<JOY_ACC

	; XvCg
	jsr	Spr_Init

	jsr	Yeild_SetEntry	; t[͂

	; ʏ
	ldx	#LOW(Vcmd_Clear)
	ldy	#HIGH(Vcmd_Clear)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; XN[I
	lda	#$a8
	sta	<PPU_REG1
	sta	$2000
	lda	#$1e
	sta	$2001

	jsr	Yeild		; t[܂őҋ@

	; ^Cg
Title_Init;

	; ~[O
	lda	#$01	; ~[O
	sta	$a000

	; oN؂ւ
	ldx	#$00
	stx	$8000
	ldy	#$00
	sty	$8001	; set CHR ROM bank4 to 0x0000 .. 0x07ff
	inx		; same as ldx #$01
	stx	$8000
	ldy	#$02
	sty	$8001	; set CHR ROM bank5 to 0x0800 .. 0x0fff

	; IRQ^XNݒ
	lda	#$00
	sta	IRQ_FNC+1
	lda	#LOW(User_Irq_Title)
	sta	IRQ_FNC
	lda	#HIGH(User_Irq_Title)
	sta	IRQ_FNC+1
	lda	#31
	sta	<IRQ_LINE

	; XN[ݒ
	lda	#$00
	sta	<SCROLL_X
	sta	<SCROLL_Y

	; ϐ
;	lda	#$00
	sta	<CUR_POS
	lda	#$01
	sta	<CUR_PREV

	; XvCgݒ
	jsr	Spr_SetTitle

	jsr	Yeild_SetEntry	; t[͂

	; ʕ`
	ldx	#LOW(Vcmd_Title)
	ldy	#HIGH(Vcmd_Title)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; tF[hC
	lda	#$40
	sta	<USR_CNT2
	lda	#4
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT2
	sec
	sbc	#$10
	sta	<USR_CNT2
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	; ZNg҂
	lda	#1
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	lda	<CUR_POS
	cmp	<CUR_PREV
	beq	.1
	sta	<CUR_PREV
	jsr	Spr_SetTitleCursor
.1:
	jsr	Joy_Title

	lda	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	; tF[hAEg
	lda	#$00
	sta	<USR_CNT2
	lda	#4
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT2
	clc
	adc	#$10
	sta	<USR_CNT2
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	; XvCg
	jsr	Spr_ClearCursor
	jsr	Spr_ClearMessage

	lda	<CUR_POS
	beq	.2
	jmp	Guide_Init
.2:

	; Q[
Game_Init:
	; tB[h
	jsr	Gem_MakeField

	; ϐ
	lda	#PHASE_NONE
	sta	<USR_PHASE
	lda	#$00
	sta	<CHAIN_CNT
	sta	<MSG_CNT
	sta	<MSG_TYPE
	sta	<CUR_PREV
	lda	#86
	sta	<CUR_POS
	lda	#180
;	lda	#5
	sta	<TIME_CNT2
	lda	#4
	sta	<TIME_CNT1

	lda	#0
	ldx	#8
.1:
	sta	<MATH_REG,x
	dex
	bpl	.1

	; ~[O
;	lda	#$00	; ~[O
	sta	$a000

	; oN؂ւ
	ldx	#$00
	stx	$8000
	ldy	#$00
	sty	$8001	; set CHR ROM bank2 to 0x0000 .. 0x07ff
	inx		; same as ldx #$01
	stx	$8000
	ldy	#$02
	sty	$8001	; set CHR ROM bank3 to 0x0800 .. 0x0fff

	; IRQ^XNݒ
	lda	#$00
	sta	IRQ_FNC+1
	lda	#LOW(User_Irq_Game)
	sta	IRQ_FNC
	lda	#HIGH(User_Irq_Game)
	sta	IRQ_FNC+1
	lda	#39
	sta	<IRQ_LINE

	; XN[ݒ
	lda	#$08
	sta	<SCROLL_X
	sta	<SCROLL_Y

	; XvCg
	jsr	Spr_ClearMessage

	jsr	Yeild_SetEntry	; t[͂

	; ʕ`(wi)
	ldx	#LOW(Vcmd_Wall)
	ldy	#HIGH(Vcmd_Wall)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; tF[hC
	jsr	PlayCurrentBgm

	lda	#$40
	sta	<USR_CNT2
	lda	#4
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT2
	sec
	sbc	#$10
	sta	<USR_CNT2
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	; ʕ`()
	lda	#96
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT
	sec
	sbc	#8
	sta	<USR_CNT
	tax
	jsr	Vcmd_Render_FieldLine

	lda	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

Game_Ready:
	; bZ[W\(Ready)
	lda	#60
	sta	<USR_CNT

	jsr	Spr_SetReadyMessage

	ldx	#LOW(SeReady1_PlayData)
	ldy	#HIGH(SeReady1_PlayData)
	jsr	SoundDriver_PlaySE_Ex

	jsr	Yeild_SetEntry	; t[͂

	dec	<USR_CNT

	lda	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	; bZ[W\(Go)
	lda	#30
	sta	<USR_CNT

	jsr	Spr_ClearMessage
	jsr	Spr_SetGoMessage

	jsr	Yeild_SetEntry	; t[͂

	dec	<USR_CNT

	lda	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	; bZ[W
	jsr	Spr_ClearMessage

	jsr	Yeild		; t[܂őҋ@

Game_Main:
	; L[͂̏
	jsr	Joy_Game

	; J[\̕\
	lda	<CUR_POS
	cmp	<CUR_PREV
	beq	.1
	sta	<CUR_PREV
	jsr	Spr_SetCursor
.1:

	; bZ[W\
	lda	<MSG_CNT
	beq	.2
	jsr	Gem_UpdateMessage
.2:

	ldx	<USR_PHASE
	lda	.jmptbl_hi,x
	pha
	lda	.jmptbl_lo,x
	pha
	rts
.jmptbl_lo:
	.db	LOW(.none-1), LOW(.revolve-1), LOW(.vanish-1)
	.db	LOW(.pack-1)
.jmptbl_hi:
	.db	HIGH(.none-1), HIGH(.revolve-1), HIGH(.vanish-1)
	.db	HIGH(.pack-1)

.revolve:
	; ]
	jsr	Gem_DoRevolve
	jsr	Spr_SetGem
	jmp	.9

.vanish:
	; 
	jsr	Gem_DoVanish
	jsr	Gem_UpdateScore
	jmp	.9

.pack:
	; lߍݏ
	jsr	Gem_DoPack
	jsr	Spr_SetGem
	jmp	.9

.none:
	; ʏ

	; ^C}[
	jsr	Gem_UpdateTime

.9:
	lda	<TIME_CNT2
	ora	<TIME_CNT1
	jsr	Yeild_Eq	; t[܂őҋ@

Game_Timeup:
	; bZ[W\(Timeup)
	lda	#180
	sta	<USR_CNT

	jsr	Spr_ClearCursor
	jsr	Spr_SetTimeupMessage

	jsr	SoundDriver_StopBGM
	ldx	#LOW(SeTimeup1_PlayData)
	ldy	#HIGH(SeTimeup1_PlayData)
	jsr	SoundDriver_PlaySE_Ex

	jsr	Yeild_SetEntry	; t[͂

	dec	<USR_CNT

	lda	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	; {^҂
	lda	#1
	sta	<MSG_CNT
	lda	#MSG_BUTTON
	sta	<MSG_TYPE
	jsr	Gem_UpdateMessage

	jsr	Yeild_SetEntry	; t[͂

	jsr	Joy_Wait

	lda	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	; bZ[W
	; tF[hAEg
	jsr	Spr_ClearMessage

	lda	#$00
	sta	<USR_CNT2
	lda	#4
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT2
	clc
	adc	#$10
	sta	<USR_CNT2
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	jmp	Title_Init

Guide_Init:
	; ~[O
	lda	#$01	; ~[O
	sta	$a000

	; oN؂ւ
	ldx	#$00
	stx	$8000
	ldy	#$08
	sty	$8001	; set CHR ROM bank4 to 0x0000 .. 0x07ff
	inx		; same as ldx #$01
	stx	$8000
	ldy	#$0a
	sty	$8001	; set CHR ROM bank5 to 0x0800 .. 0x0fff

	; IRQ^XNݒ
	lda	#$00
	sta	IRQ_FNC+1
	sta	<IRQ_LINE

	; XN[ݒ
;	lda	#$00
	sta	<SCROLL_X
	sta	<SCROLL_Y

	jsr	Yeild_SetEntry	; t[͂

	; ʕ`
	ldx	#LOW(Vcmd_Guid1)
	ldy	#HIGH(Vcmd_Guid1)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; tF[hC
	lda	#$41
	sta	<USR_CNT2
	lda	#4
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT2
	sec
	sbc	#$10
	sta	<USR_CNT2
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@
.1:
	; {^҂
	jsr	Joy_Guide

	lda	<USR_CNT
	bmi	.9
	jsr	Yeild_Eq	; t[܂őҋ@

	; ʕ`
	ldx	#LOW(Vcmd_Guid2)
	ldy	#HIGH(Vcmd_Guid2)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; {^҂
	jsr	Joy_Guide

	lda	<USR_CNT
	bmi	.9
	jsr	Yeild_Eq	; t[܂őҋ@

	; ʕ`
	ldx	#LOW(Vcmd_Guid3)
	ldy	#HIGH(Vcmd_Guid3)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@

	; {^҂
	jsr	Joy_Guide

	lda	<USR_CNT
	bmi	.9
	jsr	Yeild_Eq	; t[܂őҋ@

	; ʕ`
	ldx	#LOW(Vcmd_Guid1)
	ldy	#HIGH(Vcmd_Guid1)
	jsr	Vcmd_SequenceData

	jsr	Yeild_Eq	; t[܂őҋ@
	jmp	.1
.9:
	; tF[hAEg
	lda	#$01
	sta	<USR_CNT2
	lda	#4
	sta	<USR_CNT

	jsr	Yeild_SetEntry	; t[͂

	lda	<USR_CNT2
	clc
	adc	#$10
	sta	<USR_CNT2
	jsr	Vcmd_SetPalette

	dec	<USR_CNT
	jsr	Yeild_Eq	; t[܂őҋ@

	jmp	Title_Init

;	jsr	Yeild_ReEntry


User_Nmi:
	lda	<PPU_REG1
	and	#$fc
	sta	<PPU_REG1

	lda	#0
	sta	<IRQ_CNT

	lda	<SCROLL_Y
	clc
	adc	#32
	sta	<IRQ_Y
	lda	<SCROLL_X
	sta	<IRQ_X
	lda	<PPU_REG1
	and	#$03
	sta	<IRQ_N

	lda	$2002	; clear address latch

	rts

	; clk/line : 341ppu : 113.667 cpu
	; total 7+24+13+14+12+14+26 = 110clk
User_Irq_Title:
	inc	<IRQ_CNT	; 5
	lda	<IRQ_CNT	; 3
	cmp	#20		; 2
	bcc	.1		; 2/3

	; irq disable
	ldx	#$00		; 2
	stx	$c000		; 4
	stx	$e000		; 4
	nop			; 2
	bcs	.2		; 3 same as jmp
.1:
	; irq enable
	ldx	#5		; 2
	stx	$c000		; 4
	stx	$e000		; 4
	stx	$e001		; 4
.2:
	lda	IRQ_N		; 4
	asl	a		; 2
	asl	a		; 2
	sta	$2006		; 4

;	ldx	<SCROLL_X	; 3
	ldx	<IRQ_X		; 3
	ldy	<IRQ_Y		; 3
	sty	$2005		; 4
	stx	$2005		; 4

	txa			; 2
	lsr	a		; 2
	lsr	a		; 2
	lsr	a		; 2
	sta	<IRQ_WORK	; 3
	tya			; 2
	asl	a		; 2
	asl	a		; 2
	and	#$e0		; 2
	ora	<IRQ_WORK	; 3
	sta	$2006		; 4

;	lda	<IRQ_CNT
;	and	#$01
;	ora	#$1e
;	sta	$2001

	tya
	ldy	#0
	clc
	adc	#8
	sta	<IRQ_Y
	bcc	.3
	iny
	iny
.3
;	txa
;	clc
;	adc	#1
;	sta	<IRQ_X
;	bcc	.4
;	iny
;.4
	tya
	eor	<IRQ_N
	sta	<IRQ_N

	rts

	; clk/line : 341ppu : 113.667 cpu
	; total 7+24+13+14+10+9+20 = 97clk
User_Irq_Game:
	inc	<IRQ_CNT	; 5
	lda	<IRQ_CNT	; 3
	cmp	#12		; 2
	bcc	.1		; 3

	; irq disable
	ldx	#$00		; 2
	stx	$c000		; 4
	stx	$e000		; 4
	bcs	.2		; 3 same as jmp
.1:
	; irq enable
	ldx	#15		; 2
	stx	$c000		; 4
	stx	$e000		; 4
	stx	$e001		; 4
.2:
	and	#1		; 2
	asl	a		; 2
	asl	a		; 2
	asl	a		; 2
	tax			; 2

	lda	<PPU_REG1	; 3
	and	#$fc		; 2
;	ora	Int,x
	sta	$2000		; 4

;	clc
	lda	<SCROLL_X	; 3
	sec			; 2
	sbc	Int,x		; 4
	sta	$2005		; 4
	lda	<SCROLL_Y	; 3
	sta	$2005		; 4

	rts

