; [U^XN(Tu[`)

Joy_Title:
	lda	<JOYPAD
	eor	<JOY_PREV
	and	<JOYPAD
	tay

	and	#(JOY_A|JOY_START)
	beq	.1
	lda	#$00
	sta	<USR_CNT
.1:
	tya
	and	#(JOY_UP|JOY_DOWN|JOY_SELECT)
	beq	.2
	lda	<CUR_POS
	eor	#$01
	sta	<CUR_POS
.2:
	lda	<JOYPAD
	sta	<JOY_PREV

	rts

Joy_Game:
	lda	<JOYPAD
	eor	<JOY_PREV
	and	<JOYPAD
	tay
	ldx	#0

	and	#JOY_LEFT
	beq	.1
	lda	<CUR_POS
	eor	#$ff
	and	#$10
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	eor	<CUR_POS
	and	#$0f
	cmp	#0
	beq	.1
	dec	<CUR_POS
.1:
	tya
	and	#JOY_RIGHT
	beq	.2
	lda	<CUR_POS
	and	#$10
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	eor	<CUR_POS
	and	#$0f
	cmp	#13
	bcs	.2
	inc	<CUR_POS
.2:
	tya
	and	#JOY_UP
	beq	.3
	lda	<CUR_POS
	cmp	#16
	bcc	.3
	lsr	a
	lsr	a
	lsr	a
	ora	#$fd	; ~((~(a>>3))&2)
	sec
	adc	<CUR_POS
	sec
	sbc	#15
	sta	<CUR_POS
.3:
	tya
	and	#JOY_DOWN
	beq	.4
	lda	<CUR_POS
	cmp	#160
	bcs	.4
	and	#$10
	lsr	a
	lsr	a
	lsr	a
;	clc
	adc	<CUR_POS
	adc	#15
	sta	<CUR_POS
.4:
	tya
	and	#JOY_A
	beq	.5
	lda	<USR_PHASE
	bne	.5
	lda	#PHASE_REVOLVE
	sta	<USR_PHASE
	lda	#$01
	sta	<USR_CNT
.5:
	tya
	and	#JOY_B
	beq	.6
	lda	<USR_PHASE
	bne	.6
	lda	#PHASE_REVOLVE
	sta	<USR_PHASE
	lda	#$02
	sta	<USR_CNT
.6:
	tya
	and	#JOY_START
	beq	.7
	ldx	#1
.7:
	lda	<JOYPAD
	sta	<JOY_PREV

	; J[\s[g
	and	#JOY_UP|JOY_DOWN|JOY_LEFT|JOY_RIGHT
	beq	.11

	dec	<JOY_CNT
	bne	.12
	eor	<JOY_PREV
	sta	<JOY_PREV
	lda	<JOY_ACC
	cmp	#5
	bcc	.10
	dec	<JOY_ACC
	dec	<JOY_ACC
.10:
	lda	<JOY_ACC
	sta	<JOY_CNT
	bne	.12	; same as jmp
.11:
	lda	#12
	sta	<JOY_CNT
	sta	<JOY_ACC
.12:

	; BGMZNg
	cpx	#1
	bne	.20
	jsr	PlayNextBgm
.20:

	rts

Joy_Wait:
	lda	#$01
	sta	<USR_CNT

	lda	<JOYPAD
	eor	<JOY_PREV
	and	<JOYPAD
	tay

	and	#JOY_A
	beq	.1
	lda	#$00
	sta	<USR_CNT
.1:
	lda	<JOYPAD
	sta	<JOY_PREV

	rts

Joy_Guide:
	lda	#$01
	sta	<USR_CNT

	lda	<JOYPAD
	eor	<JOY_PREV
	and	<JOYPAD
	tay

	and	#(JOY_A|JOY_B)
	beq	.1
	lsr	a
	lda	#$00
	adc	#$ff
	sta	<USR_CNT
.1:
	lda	<JOYPAD
	sta	<JOY_PREV

	rts

Gem_SetNearbyGemPos:
	ldy	Field_LeftUpper,x
	sty	<FNC_WORK+2 ; pos
	ldy	Field_RightUpper,x
	sty	<FNC_WORK+3 ; Epos
	ldy	Field_Left,x
	sty	<FNC_WORK+4 ; pos
	ldy	Field_Right,x
	sty	<FNC_WORK+5 ; Epos
	ldy	Field_LeftLower,x
	sty	<FNC_WORK+6 ; pos
	ldy	Field_RightLower,x
	sty	<FNC_WORK+7 ; Epos
	rts

Gem_MakeField:
	; tB[hGemݒ肷
	ldx	#96
.A1:
	txa
	and	#15
	bne	.A2
	lda	#(BLK_WALL & $0f)
	bne	.A3		; same as jmp
.A2:
	jsr	Gem_GetRandomGem
.A3:
	sta	OBJ_FIELD-1,x
	dex
	bne	.A1

.check
	; uRAȏtOv($40)𗧂Ă
	ldx	#95
.B1:
	lda	OBJ_FIELD,x
	and	#$0f
	sta	<FNC_WORK+1

	jsr	Gem_SetNearbyGemPos

	lda	#0
	sta	<FNC_WORK
	stx	<FNC_WORK+8
	ldx	#5
.B2:
	ldy	<FNC_WORK+2,x
	bmi	.B3		; tB[h̊O͏O
	lda	OBJ_FIELD,y
	and	#$0f
	cmp	<FNC_WORK+1
	bne	.B3		; Gem̎ނقȂ
	inc	<FNC_WORK
.B3:
	dex
	bpl	.B2
	ldx	<FNC_WORK+8

	lda	OBJ_FIELD,x
	ldy	<FNC_WORK
	cpy	#2
	bcc	.B4

	ora	#$40
	sta	OBJ_FIELD,x
.B4:
	dex
	bne	.B1

	; Ǝ̓FGemɁuRAȏtOvĂA
	; ̓FGemɁuύXtOvĂȂGem
	; uύXtOv($80)𗧂Ă
	ldx	#95
.C1:
	lda	OBJ_FIELD,x
	cmp	#$40
	bcc	.C5

	jsr	Gem_SetNearbyGemPos

	stx	<FNC_WORK+8

	and	#$0f
	sta	<FNC_WORK+1

	lda	#0
	sta	<FNC_WORK
	ldx	#5
.C2:
	ldy	<FNC_WORK+2,x
	bmi	.C3		; tB[h̊O͏O
	lda	OBJ_FIELD,y
	and	#$0f
	cmp	<FNC_WORK+1
	bne	.C3		; Gem̎ނقȂ
	lda	OBJ_FIELD,y
	bmi	.C4		; uύXtOvĂΕύX
	cmp	#$40
	bcc	.C3		; uRAȏtOvĂȂΏO
	inc	<FNC_WORK
.C3:
	dex
	bpl	.C2

	lda	<FNC_WORK
	beq	.C4

	ldx	<FNC_WORK+8
	lda	<FNC_WORK+1
	ora	#$80
	sta	OBJ_FIELD,x
.C4:
	ldx	<FNC_WORK+8
.C5:
	dex
	bpl	.C1

	; uύXtOvĂGem𑼂GemɕύX
	; uύXtOvuRAȏtOv
	lda	#(BLK_WALL & $0f)
	sta	<FNC_WORK+1
	ldx	#95
.D1:
	lda	OBJ_FIELD,x
	bpl	.D9

	jsr	Gem_SetNearbyGemPos

	stx	<FNC_WORK+8

.D2:
	dec	<FNC_WORK+1
	bne	.D3
	lda	#(BLK_WALL & $0f)-1
	sta	<FNC_WORK+1
.D3:
	ldx	#5
.D4:
	ldy	<FNC_WORK+2,x
	bmi	.D5		; tB[h̊O͏O
	lda	OBJ_FIELD,y
	and	#$0f
	cmp	<FNC_WORK+1
	beq	.D2
.D5:
	dex
	bpl	.D4

	lda	<FNC_WORK+1
	ldx	<FNC_WORK+8
.D9:
	and	#$0f
	sta	OBJ_FIELD,x
	dex
	bpl	.D1

	rts

Gem_DoRevolve:
	lda	<USR_CNT
	cmp	#$04
	bcc	.init

	; ]Gem̍XV
	and	#$04
	bne	.mov2

	ldx	#2
.mov1:
	lda	<GEM_POSX,x
	clc
	adc	<GEM_SPDX,x
	sta	<GEM_POSX,x
	lda	<GEM_POSY,x
	clc
	adc	<GEM_SPDY,x
	sta	<GEM_POSY,x
	dex
	bpl	.mov1
.mov2:
	lda	<USR_CNT
	sec
	sbc	#$04
	cmp	#$04
	bcs	.mov4

	ldy	#2
.mov3:
	lda	#$00
	sta	GEM_TYPE,y
	ldx	<GEM_POS,y
	lda	OBJ_FIELD,x
	and	#$0f
	sta	OBJ_FIELD,x
	sty	<FNC_WORK+4
	jsr	Vcmd_Render_FieldBlock
	ldy	<FNC_WORK+4
	dey
	bpl	.mov3

	lda	#PHASE_VANISH
	sta	<USR_PHASE
	lda	#$00
.mov4:
	sta	<USR_CNT
	rts

.init:
	; ]Gem̏
	lda	<CUR_POS
	and	#$f0
	tay
	lsr	a
	and	#$08
	tax
	lda	<CUR_POS
	and	#$0f
	asl	a
	asl	a
	asl	a
;	clc
	adc	Int,x
	tax
	lda	<CUR_POS
	and	#$01
	beq	.ini3

	; tOp`
	txa
;	clc
	adc	#16
	sta	<GEM_POSX
;	clc
	adc	#8
	sta	<GEM_POSX+2
;	clc
	adc	#8
	sta	<GEM_POSX+1

	tya
;	clc
	adc	#23
	sta	<GEM_POSY
	sta	<GEM_POSY+1
;	clc
	adc	#16
	sta	<GEM_POSY+2

	lda	<CUR_POS
	lsr	a
	tax
	stx	<GEM_POS
	ldy	OBJ_FIELD,x
	lda	.type,y
	sta	<GEM_TYPE
	lda	Int+1,x
	sta	<GEM_POS+1
	ldy	OBJ_FIELD+1,x
	lda	.type,y
	sta	<GEM_TYPE+1
	txa
	and	#$08
	beq	.ini1
	inx
.ini1:
	lda	Int+8,x
	sta	<GEM_POS+2
	ldy	OBJ_FIELD+8,x
	lda	.type,y
	sta	<GEM_TYPE+2
	lda	#$00
	sta	<GEM_TYPE+3

	lda	<USR_CNT
	cmp	#$01
	bne	.ini2

	; tOp`v
	lda	#$02
	sta	<GEM_SPDX
	sta	<GEM_SPDY+1
	lda	#$ff
	sta	<GEM_SPDX+1
	sta	<GEM_SPDX+2
	lda	#$00
	sta	<GEM_SPDY
	lda	#$fe
	sta	<GEM_SPDY+2
	jmp	.ini6
.ini2:
	; tOp`tv
	lda	#$fe
	sta	<GEM_SPDX+1
	sta	<GEM_SPDY+2
	lda	#$01
	sta	<GEM_SPDX+2
	sta	<GEM_SPDX
	lda	#$00
	sta	<GEM_SPDY+1
	lda	#$02
	sta	<GEM_SPDY
	jmp	.ini7
.ini3:
	; Op`
	txa
;	clc
	adc	#16
	sta	<GEM_POSX+1
;	clc
	adc	#8
	sta	<GEM_POSX
;	clc
	adc	#8
	sta	<GEM_POSX+2

	tya
;	clc
	adc	#23
	sta	<GEM_POSY
;	clc
	adc	#16
	sta	<GEM_POSY+1
	sta	<GEM_POSY+2

	lda	<CUR_POS
	lsr	a
	tax
	stx	<GEM_POS
	ldy	OBJ_FIELD,x
	lda	.type,y
	sta	<GEM_TYPE
	txa
	and	#$08
	beq	.ini4
	inx
.ini4:
	lda	Int+7,x
	sta	<GEM_POS+1
	ldy	OBJ_FIELD+7,x
	lda	.type,y
	sta	<GEM_TYPE+1
	lda	Int+8,x
	sta	<GEM_POS+2
	ldy	OBJ_FIELD+8,x
	lda	.type,y
	sta	<GEM_TYPE+2
	lda	#$00
	sta	<GEM_TYPE+3

	lda	<USR_CNT
	cmp	#$01
	bne	.ini5

	; Op`v
	lda	#$01
	sta	<GEM_SPDX
	sta	<GEM_SPDX+1
	lda	#$fe
	sta	<GEM_SPDX+2
	sta	<GEM_SPDY+1
	lda	#$02
	sta	<GEM_SPDY
	lda	#$00
	sta	<GEM_SPDY+2
	jmp	.ini7
.ini5:
	; Op`tv
	lda	#$ff
	sta	<GEM_SPDX+2
	sta	<GEM_SPDX
	lda	#$02
	sta	<GEM_SPDX+1
	sta	<GEM_SPDY
	lda	#$fe
	sta	<GEM_SPDY+2
	lda	#$00
	sta	<GEM_SPDY+1
.ini6:
	ldx	<GEM_POS
	lda	OBJ_FIELD,x
	ora	#$80
	ldx	<GEM_POS+1
	ldy	OBJ_FIELD,x
	sta	OBJ_FIELD,x
	tya
	ora	#$80
	ldx	<GEM_POS+2
	ldy	OBJ_FIELD,x
	sta	OBJ_FIELD,x
	tya
	ora	#$80
	ldx	<GEM_POS
	sta	OBJ_FIELD,x
	jmp	.ini8
.ini7:
	ldx	<GEM_POS+2
	lda	OBJ_FIELD,x
	ora	#$80
	ldx	<GEM_POS+1
	ldy	OBJ_FIELD,x
	sta	OBJ_FIELD,x
	tya
	ora	#$80
	ldx	<GEM_POS
	ldy	OBJ_FIELD,x
	sta	OBJ_FIELD,x
	tya
	ora	#$80
	ldx	<GEM_POS+2
	sta	OBJ_FIELD,x
.ini8:
	ldy	#2
.ini9:
	ldx	<GEM_POS,y
	sty	<FNC_WORK+4
	jsr	Vcmd_Render_FieldBlock
	ldy	<FNC_WORK+4
	dey
	bpl	.ini9

	lda	<USR_CNT
	ora	#$3c
	sta	<USR_CNT
	rts
.type:
	.db	$00,                $40+(SPR_GEM0A>>2)
	.db	$00+(SPR_GEM1A>>2), $80+(SPR_GEM2A>>2)
	.db	$40+(SPR_GEM3A>>2), $00+(SPR_GEM4A>>2)
	.db	$80+(SPR_GEM5A>>2), $c0

Gem_DoVanish:
	lda	<USR_CNT
	beq	.init

	; Gem̏XV
	ldx	#95
.upd1:
	lda	OBJ_FIELD,x
	bpl	.upd2
	dec	<USR_CNT
	lda	#$00
	sta	OBJ_FIELD,x
	jsr	Vcmd_Render_FieldBlock
	ldx	#0
	ldy	#3
	jsr	Math_AddReg
	jmp	.upd3
.upd2:
	dex
	bpl	.upd1
.upd3:
	lda	<USR_CNT
	bne	.upd9
	lda	#PHASE_PACK
	sta	USR_PHASE
.upd9
	rts

.init:
	; Gem̏

	; QȏɓނGemӏ
	; uRAȏtOv($20)𗧂Ă
	; Q݂̂ɓނGemӏ
	; uRÂ݃tOv($10)𗧂Ă
	ldx	#95
.iniA1:
	lda	OBJ_FIELD,x
	beq	.iniA5		; 󔒂͏O
	and	#$0f
	sta	<FNC_WORK+1

	jsr	Gem_SetNearbyGemPos

	lda	#0
	sta	<FNC_WORK
	stx	<FNC_WORK+8
	ldx	#5
.iniA2:
	ldy	<FNC_WORK+2,x
	bmi	.iniA3		; tB[h̊O͏O
	lda	OBJ_FIELD,y
	and	#$0f
	cmp	<FNC_WORK+1
	bne	.iniA3		; Gem̎ނقȂor
	inc	<FNC_WORK
.iniA3:
	dex
	bpl	.iniA2
	ldx	<FNC_WORK+8

	lda	OBJ_FIELD,x
	ldy	<FNC_WORK
	cpy	#2
	bcc	.iniA5
	bne	.iniA4

	ora	#$10
.iniA4:
	ora	#$20
	sta	OBJ_FIELD,x

.iniA5:
	dex
	bpl	.iniA1

	; uRÂ݃tOvĂ铯ނGem
	; Op`ɕłꍇo
	; uRÂ݃tOvuRAȏtOv
	ldx	#95
.iniB1:
	lda	OBJ_FIELD,x
	and	#$1f
	cmp	#$10
	bcc	.iniB4
	sta	<FNC_WORK+1

	ldy	Field_LeftUpper,x
	bmi	.iniB2
	sty	<FNC_WORK+2
	lda	OBJ_FIELD,y
	and	#$1f
	cmp	<FNC_WORK+1
	bne	.iniB2

	ldy	Field_RightUpper,x
	bmi	.iniB2
	sty	<FNC_WORK+3
	lda	OBJ_FIELD,y
	and	#$1f
	cmp	<FNC_WORK+1
;	bne	.iniB2
	beq	.iniB3		; same as jmp
.iniB2:
	ldy	Field_LeftLower,x
	bmi	.iniB4
	sty	<FNC_WORK+2
	lda	OBJ_FIELD,y
	and	#$1f
	cmp	<FNC_WORK+1
	bne	.iniB4

	ldy	Field_RightLower,x
	bmi	.iniB4
	sty	<FNC_WORK+3
	lda	OBJ_FIELD,y
	and	#$1f
	cmp	<FNC_WORK+1
	bne	.iniB4
.iniB3:
	lda	OBJ_FIELD,x
	and	#$0f
	sta	OBJ_FIELD,x
	ldy	<FNC_WORK+2
	lda	OBJ_FIELD,y
	and	#$0f
	sta	OBJ_FIELD,y
	ldy	<FNC_WORK+3
	lda	OBJ_FIELD,y
	and	#$0f
	sta	OBJ_FIELD,y

.iniB4:
	dex
	bpl	.iniB1

	; ƎɁuRAȏtOvGem
	; utOv($80)𗧂Ă
	; ɁuRAȏtOvuRÂ݃tOvȂGem
	; utOv($80)𗧂Ă
	; Lꂩ̏ɓĂ͂܂A̓ނGem
	; uRAȏtOvĂȂGem
	; utOv($80)𗧂Ă
	ldx	#95
.iniC1:
	lda	OBJ_FIELD,x
	beq	.iniC9		; 󔒂͏O
	cmp	#$20
	bcc	.iniC9		; tOĂȂΏO

	jsr	Gem_SetNearbyGemPos

	stx	<FNC_WORK+8

	and	#$1f
	cmp	#$10
	bcc	.iniC5		; uRAȏtOvĂꍇ͏

	and	#$0f
	sta	<FNC_WORK+1

	ldx	#5
.iniC2:
	ldy	<FNC_WORK+2,x
	bmi	.iniC3		; tB[h̊O͏O
	lda	OBJ_FIELD,y
	cmp	#$20
	bcc	.iniC3		; uRAȏtOvĂȂΏO
	and	#$0f
	cmp	<FNC_WORK+1
	beq	.iniC4		; Gem̎ނ
.iniC3:
	dex
	bpl	.iniC2
	bmi	.iniC8		; same as jmp

.iniC4:
	ldx	<FNC_WORK+8
	lda	OBJ_FIELD,x
.iniC5:
	and	#$0f
	sta	<FNC_WORK+1
	ora	#($80+$20)
	sta	OBJ_FIELD,x

	ldx	#5
.iniC6:
	ldy	<FNC_WORK+2,x
	bmi	.iniC7		; tB[h̊O͏O
	lda	OBJ_FIELD,y
	cmp	#$20
	bcs	.iniC7		; tOĂӏ͏O
	cmp	<FNC_WORK+1
	bne	.iniC7		; Gem̎ނقȂor󔒂͏O
	ora	#$80
	sta	OBJ_FIELD,y
.iniC7:
	dex
	bpl	.iniC6
.iniC8:
	ldx	<FNC_WORK+8
.iniC9:
	dex
	bpl	.iniC1

	; uRÂ݃tOvƁuRAȏtOv
	; utOv̐JEg
	ldy	#0
	ldx	#95
.iniD1:
	lda	OBJ_FIELD,x
	and	#$cf
	sta	OBJ_FIELD,x
	bpl	.iniD2
	iny
.iniD2:
	dex
	bpl	.iniD1
	sty	<USR_CNT

	cpy	#0
	beq	.iniE4
	; ΂̏
	inc	<CHAIN_CNT
	ldx	<CHAIN_CNT
	cpx	#11
	bcc	.iniE2
	cpx	#20
	bcc	.iniE1
	ldx	#1
	jsr	Time_AddSecond
	jsr	Vcmd_Render_Time
.iniE1:
	ldx	#10
.iniE2:
	lda	.Point-1,x
	sta	<MATH_REG+3

	ldx	<CHAIN_CNT
	dex
	beq	.iniE3
	lda	#1
	sta	<MSG_CNT
	lda	#MSG_CHAIN
	sta	<MSG_TYPE
.iniE3:
	jmp	PlaySeVanish
;	jsr	PlaySeVanish
;	jmp	.iniE5

.iniE4:
	; ΂̏Ȃ
	lda	<USR_PHASE
	sec
	sbc	#PHASE_VANISH
	ora	<CHAIN_CNT
;	ldy	#$00
	sty	<USR_PHASE
	sty	<CHAIN_CNT
	sty	<MATH_REG+3
;	cmp	#0
	bne	.iniE5

	ldx	#1
	jsr	Time_SubSecond
	jsr	Vcmd_Render_Time

	ldx	#LOW(SeMiss1_PlayData)
	ldy	#HIGH(SeMiss1_PlayData)
;	jsr	SoundDriver_PlaySE_Ex
	jmp	SoundDriver_PlaySE_Ex

.iniE5:
	rts

.Point:
	.db	1, 2, 3, 5, 10, 20, 30, 50, 100, 200


Gem_DoPack:
	lda	<USR_CNT
	and	#$f0
	beq	.init
	lda	<USR_CNT
	sec
	sbc	#$10
	sta	<USR_CNT
	jmp	.mov

	; Gem̈ړ̏
.init:
	ldy	#0
	ldx	#3
.iniA1:
	lda	GEM_CNT,x
	beq	.iniA2
	dex
	bpl	.iniA1
	bmi	.iniA3	; same as jmp
.iniA2:
	stx	<FNC_WORK+9
	iny

.iniA3:
	ldx	#3
.iniA4:
	lda	GEM_CNT+4,x
	beq	.iniA5
	dex
	bpl	.iniA4
	bmi	.iniA6	; same as jmp
.iniA5:
	lda	Int+4,x
	sta	<FNC_WORK+10
	iny
	iny

.iniA6:
	tya
	sta	<FNC_WORK+8
	bne	.iniB1
	jmp	.mov

.iniB1:
	ldx	#87
.iniB2:
	lda	OBJ_FIELD,x
	beq	.iniB6
	cmp	#(BLK_WALL & $0f)
	bcs	.iniB6

	txa
	and	#$08
	bne	.iniB4

	lda	<FNC_WORK+8
	and	#$02
	beq	.iniB6
	ldy	Field_LeftLower,x
	bmi	.iniB3
	lda	OBJ_FIELD,y
	beq	.iniC1
.iniB3:
	ldy	Field_RightLower,x
	bmi	.iniB6
	lda	OBJ_FIELD,y
	beq	.iniC2
	bne	.iniB6		; same as jmp
.iniB4:
	lda	<FNC_WORK+8
	and	#$01
	beq	.iniB6
	ldy	Field_RightLower,x
	bmi	.iniB5
	lda	OBJ_FIELD,y
	beq	.iniC2
.iniB5:
	ldy	Field_LeftLower,x
	bmi	.iniB6
	lda	OBJ_FIELD,y
	beq	.iniC1
.iniB6:
	dex
	bpl	.iniB2

	lda	<FNC_WORK+8
	and	#$01
	beq	.iniB7
	jmp	.add
.iniB7:
	jmp	.mov

.iniC1:
	lda	#$ff
	.db	$2c	; bit $01a9
.iniC2:
	lda	#$01
	sta	<FNC_WORK+3
	lda	#$02
	sta	<FNC_WORK+4
	stx	<FNC_WORK+6
	sty	<FNC_WORK+5
	lda	OBJ_FIELD,x
	ora	#$80
	sta	OBJ_FIELD,y
	and	#$0f
	tay
	lda	.type,y
	sta	<FNC_WORK
	lda	#$00
	sta	OBJ_FIELD,x

	txa
	asl	a
	and	#$f0
;	clc
	adc	#23
	sta	<FNC_WORK+2
	txa
	and	#$0f
	cmp	#$08
	and	#$07
	rol	a
	asl	a
	asl	a
	asl	a
;	clc
	adc	#24
	sta	<FNC_WORK+1

	stx	<FNC_WORK+7
	txa
	and	#$08
	bne	.iniC3
	ldx	<FNC_WORK+10
	lda	#$02
	bne	.iniC4		; same as jmp
.iniC3:
	ldx	<FNC_WORK+9
	lda	#$01
.iniC4:
	eor	<FNC_WORK+8
	sta	<FNC_WORK+8

	lda	<FNC_WORK
	sta	<GEM_TYPE,x
	lda	<FNC_WORK+1
	sta	<GEM_POSX,x
	lda	<FNC_WORK+2
	sta	<GEM_POSY,x
	lda	<FNC_WORK+3
	sta	<GEM_SPDX,x
	lda	<FNC_WORK+4
	sta	<GEM_SPDY,x
	lda	<FNC_WORK+5
	sta	<GEM_POS,x
;		lda	#127
	lda	#8
	sta	<GEM_CNT,x
	ldx	<FNC_WORK+6
	jsr	Vcmd_Render_FieldBlock
	inc	<USR_CNT
	lda	<USR_CNT
	ora	#$10
	sta	<USR_CNT

	ldx	<FNC_WORK+7
	lda	<FNC_WORK+8
	beq	.mov
	jmp	.iniB6

	; Gem̒ǉ
.add
	lda	<FNC_WORK+9
	sta	<FNC_WORK+4
	ldx	#7
.add1:
	lda	OBJ_FIELD,x
	beq	.add2
	dex
	bpl	.add1
	bmi	.mov
.add2:
	stx	<FNC_WORK+6

	txa
	asl	a
	asl	a
	asl	a
	asl	a
;	clc
	adc	#16
	sta	<FNC_WORK+5

	jsr	Gem_GetRandomGem
	ora	#$80
	sta	OBJ_FIELD,x
	and	#$0f
	tay
	lda	.type,y

	ldx	<FNC_WORK+4
	sta	<GEM_TYPE,x
	lda	<FNC_WORK+5
	sta	<GEM_POSX,x
	lda	#7
	sta	<GEM_POSY,x
	lda	#1
	sta	<GEM_SPDX,x
	lda	#2
	sta	<GEM_SPDY,x
	lda	<FNC_WORK+6
	sta	<GEM_POS,x
;		lda	#127
	lda	#8
	sta	<GEM_CNT,x

	inc	<USR_CNT
	lda	<USR_CNT
	ora	#$10
	sta	<USR_CNT

	; Gem̈ړ
.mov
	ldx	#7
.mov1:
	lda	<GEM_CNT,x
	beq	.mov3
;		and	#$0f
;		bne	.mov2
	lda	<GEM_POSX,x
	clc
	adc	<GEM_SPDX,x
	sta	<GEM_POSX,x
	lda	<GEM_POSY,x
	clc
	adc	<GEM_SPDY,x
	sta	<GEM_POSY,x
.mov2:
	dec	<GEM_CNT,x
	bne	.mov3
	lda	#$00
	sta	<GEM_TYPE,x
	ldy	<GEM_POS,x
	lda	OBJ_FIELD,y
	and	#$0f
	sta	OBJ_FIELD,y
	stx	<FNC_WORK+4
	ldx	Int,y
	jsr	Vcmd_Render_FieldBlock
	ldx	<FNC_WORK+4
	dec	<USR_CNT
.mov3:
	dex
	bpl	.mov1

	lda	<USR_CNT
	bne	.mov5

	; ォRiڂ̍E[󂢂Ԃ
	; lߏIꍇ̂
	; ʂRiɋ󂫂ȂmF
	ldx	#$17
.mov4:
	lda	OBJ_FIELD,x
	beq	.mov5
	bmi	.mov5
	dex
	bpl	.mov4

	lda	#PHASE_VANISH
	sta	<USR_PHASE
.mov5:
	rts
.type:
	.db	$00,                $40+(SPR_GEM0A>>2)
	.db	$00+(SPR_GEM1A>>2), $80+(SPR_GEM2A>>2)
	.db	$40+(SPR_GEM3A>>2), $00+(SPR_GEM4A>>2)
	.db	$80+(SPR_GEM5A>>2), $c0

Gem_GetRandomGem:
	lda	#$00
	sta	<FNC_WORK

	jsr	Rand
	tay
	asl	a
	rol	<FNC_WORK
	adc	Int,y
	bcc	.1
	inc	<FNC_WORK
.1:
	asl	a
	rol	<FNC_WORK
	inc	<FNC_WORK
	lda	<FNC_WORK
	rts

	; XRAXV
Gem_UpdateScore:
	ldx	#6
	ldy	#0
	jsr	Math_CmpReg
	beq	.2
	jsr	Math_MoveReg
	jsr	Math_RegToBCD
	ldx	#6
.1:
	lda	<FNC_ARG+1,x
	asl	a
	adc	#BG_LARGE_NUM0A
	sta	VBUF_BLK1,x
	ora	#1
	sta	VBUF_BLK2,x
	dex
	bpl	.1

	ldx	#LOW(Vcmd_Score1)
	ldy	#HIGH(Vcmd_Score1)
	jsr	Vcmd_SetData

	ldx	#LOW(Vcmd_Score2)
	ldy	#HIGH(Vcmd_Score2)
	jsr	Vcmd_SetData
.2:
	rts

	; bZ[W\XV
Gem_UpdateMessage:
	dec	<MSG_CNT
	bne	.9

	lda	<MSG_TYPE
	cmp	#MSG_BUTTON
	bne	.1
	jmp	Vcmd_Render_MsgButton
.1:
	cmp	#MSG_CHAIN
	bne	.2
	lda	#240
	sta	<MSG_CNT
	lda	#MSG_NONE
	sta	<MSG_TYPE
	jmp	Vcmd_Render_MsgChain
.2:
	jmp	Vcmd_Render_MsgNone
.9:
	rts

	; ^C}[\XV
Gem_UpdateTime:
	jsr	Time_DecFrame
	beq	.1
	jmp	Vcmd_Render_Time
.1
	rts

	; x : field pos (x+y*8)
Vcmd_Render_FieldBlock:
	lda	#$00
	sta	<FNC_WORK+2
	txa
	and	#$07
	sta	<FNC_WORK
	txa
	lsr	a
	lsr	a
	lsr	a
	sta	<FNC_WORK+1

	; l[e[uVCMD
	lda	#$02
	sta	VCMD_BLK1 ; byte
	sta	VCMD_BLK2 ; byte
	lda	#$00
	sta	VCMD_BLK1+1 ; tO
	sta	VCMD_BLK2+1 ; tO
	lda	#HIGH(Block_Data)
	sta	VCMD_BLK1+5 ; ]AhX
	sta	VCMD_BLK2+5 ; ]AhX

	lda	OBJ_FIELD,x
	cmp	#$08
	bcc	.1
	lda	#$00
.1:
	tax
	lda	Gem_To_Block,x
	asl	a
	rol	<FNC_WORK+2
	asl	a
	rol	<FNC_WORK+2
	sta	VCMD_BLK1+4 ; ]AhX
;	clc
	adc	#$02
	sta	VCMD_BLK2+4 ; ]AhX

	ldx	<FNC_WORK+1
	lda	<FNC_WORK
	asl	a
;	clc
	adc	Field_OVA_L,x
	sta	VCMD_BLK1+2 ; ]AhX
	eor	#$20
	sta	VCMD_BLK2+2 ; ]AhX
	lda	#$00
	adc	Field_OVA_H,x
	sta	VCMD_BLK1+3 ; ]AhX
	sta	VCMD_BLK2+3 ; ]AhX

	; e[uVCMD
	lda	<FNC_WORK+2
	lsr	<FNC_WORK+1
	rol	a
	lsr	<FNC_WORK
	rol	a
	tax

	lda	#$01
	sta	VCMD_ATTR ; byte
	lda	#$00
	sta	VCMD_ATTR+1 ; tO

	lda	<FNC_WORK+1
	asl	a
	asl	a
	eor	<FNC_WORK
	tay
;	clc
	adc	#LOW(ATTR_FIELD)
	sta	VCMD_ATTR+4 ; ]AhX
	lda	#$00
	adc	#HIGH(ATTR_FIELD)
	sta	VCMD_ATTR+5 ; ]AhX

	lda	ATTR_FIELD,y
	and	Attr_Mask,x
	ora	Attr_Value,x
	sta	ATTR_FIELD,y

	ldx	<FNC_WORK+1
	lda	Field_AVA_L,x
	clc
	adc	<FNC_WORK
	sta	VCMD_ATTR+2 ; ]AhX
	lda	Field_AVA_H,x
	adc	#$00
	sta	VCMD_ATTR+3 ; ]AhX

Vcmd_Render_FieldBlock_Exec:
	; VCMDs
	ldx	#LOW(VCMD_BLK1)
	ldy	#HIGH(VCMD_BLK1)
	jsr	Vcmd_SetData
	ldx	#LOW(VCMD_BLK2)
	ldy	#HIGH(VCMD_BLK2)
	jsr	Vcmd_SetData
	ldx	#LOW(VCMD_ATTR)
	ldy	#HIGH(VCMD_ATTR)
	jmp	Vcmd_SetData

	; x : field line (y*8)
Vcmd_Render_FieldLine:
	txa
	lsr	a
	lsr	a
	lsr	a
	sta	<FNC_WORK+3
	tay

	; l[e[uVCMD
	lda	#$10
	sta	VCMD_BLK1 ; byte
	sta	VCMD_BLK2 ; byte
	lda	#$00
	sta	VCMD_BLK1+1 ; tO
	sta	VCMD_BLK2+1 ; tO
	lda	Field_OVA_L,y
	sta	VCMD_BLK1+2 ; ]AhX
	eor	#$20
	sta	VCMD_BLK2+2 ; ]AhX
	lda	Field_OVA_H,y
	sta	VCMD_BLK1+3 ; ]AhX
	sta	VCMD_BLK2+3 ; ]AhX
	lda	#LOW(VBUF_BLK1)
	sta	VCMD_BLK1+4 ; ]AhX
	lda	#LOW(VBUF_BLK2)
	sta	VCMD_BLK2+4 ; ]AhX
	lda	#HIGH(VBUF_BLK1)
	sta	VCMD_BLK1+5 ; ]AhX
;	lda	#HIGH(VBUF_BLK2)
	sta	VCMD_BLK2+5 ; ]AhX

	txa
	ora	#$07
	sta	<FNC_WORK

	ldx	#7
	ldy	#15
.1:
	stx	<FNC_WORK+1
	sty	<FNC_WORK+2
	lda	#$00
	sta	<FNC_WORK+4,x
	ldy	<FNC_WORK
	dec	<FNC_WORK
	lda	OBJ_FIELD,y
	cmp	#$08
	bcc	.2
	lda	#$00
.2:
	tay
	lda	Gem_To_Block,y
	asl	a
	rol	<FNC_WORK+4,x
	asl	a
	rol	<FNC_WORK+4,x
	tax
	ldy	<FNC_WORK+2
	lda	Block_Data+1,x
	sta	VBUF_BLK1,y
	lda	Block_Data+3,x
	sta	VBUF_BLK2,y
	dey
	lda	Block_Data,x
	sta	VBUF_BLK1,y
	lda	Block_Data+2,x
	sta	VBUF_BLK2,y
	dey
	ldx	<FNC_WORK+1
	dex
	bpl	.1

	lda	#$00
	lsr	<FNC_WORK+3
	rol	a
	asl	a
	sta	<FNC_WORK

	; e[uVCMD
	lda	#$04
	sta	VCMD_ATTR ; byte
	lda	#$00
	sta	VCMD_ATTR+1 ; tO
	lda	<FNC_WORK+3
	tax
	ldy	Field_AVA_L,x
	sty	VCMD_ATTR+2 ; ]AhX
	ldy	Field_AVA_H,x
	sty	VCMD_ATTR+3 ; ]AhX
	asl	a
	asl	a
	sta	<FNC_WORK+3
;	clc
	adc	#LOW(ATTR_FIELD)
	sta	VCMD_ATTR+4 ; ]AhX
	lda	#$00
	adc	#HIGH(ATTR_FIELD)
	sta	VCMD_ATTR+5 ; ]AhX

	asl	<FNC_WORK+3

	ldx	#7
.3:
	stx	<FNC_WORK+1
	lda	<FNC_WORK+4,x
	asl	a
	asl	a
	ora	<FNC_WORK
	eor	#01
	tax
	and	#$03
	sta	<FNC_WORK

	lda	<FNC_WORK+3
	ora	<FNC_WORK+1
	lsr	a
	tay

	lda	ATTR_FIELD,y
	and	Attr_Mask,x
	ora	Attr_Value,x
	sta	ATTR_FIELD,y

	ldx	<FNC_WORK+1
	dex
	bpl	.3

	; VCMDs
	jmp	Vcmd_Render_FieldBlock_Exec

Vcmd_Render_MsgNone:
	ldx	#LOW(Vcmd_MsgNone)
	ldy	#HIGH(Vcmd_MsgNone)
	jmp	Vcmd_SequenceData

Vcmd_Render_MsgChain:
	lda	<CHAIN_CNT
	jsr	Math_ByteToBCD

	ldx	#2
.1:
	lda	<FNC_ARG,x
	asl	a
	adc	#BG_LARGE_NUM0A
	sta	VBUF_BLK1,x
	ora	#1
	sta	VBUF_BLK2,x
	dex
	bpl	.1

	ldx	#BG_TILE0
	lda	<CHAIN_CNT
	cmp	#100
	bcs	.2
	stx	VBUF_BLK1
	stx	VBUF_BLK2
.2:
	cmp	#10
	bcs	.3
	stx	VBUF_BLK1+1
	stx	VBUF_BLK2+1
.3:

	ldx	#3
.4:
	lda	.data1,x
	sta	VBUF_BLK1+3,x
	lda	.data2,x
	sta	VBUF_BLK2+3,x
	dex
	bpl	.4

	; VCMDs
	ldx	#LOW(Vcmd_Chain1)
	ldy	#HIGH(Vcmd_Chain1)
	jsr	Vcmd_ExtractData
	ldx	#LOW(Vcmd_Chain2)
	ldy	#HIGH(Vcmd_Chain2)
	jsr	Vcmd_SetData
	ldx	#LOW(Vcmd_Chain3)
	ldy	#HIGH(Vcmd_Chain3)
	jmp	Vcmd_SetData

.data1:
	.db	BG_CHAIN0, BG_CHAIN1
	.db	BG_CHAIN4, BG_CHAIN5
.data2:
	.db	BG_CHAIN2, BG_CHAIN3
	.db	BG_CHAIN6, BG_CHAIN7

Vcmd_Render_MsgButton:
	ldx	#LOW(Vcmd_MsgButton)
	ldy	#HIGH(Vcmd_MsgButton)
	jmp	Vcmd_SequenceData

Vcmd_Render_Time:
	ldx	<TIME_CNT2
	lda	<TIME_CNT1
	and	#$03
	tay
	jsr	Math_WordToBCD

	ldx	#0
	ldy	#2
.1:
	lda	<FNC_ARG+1,x
	bne	.2
	lda	#BG_TILE0
	sta	VBUF_BLK1,x
	sta	VBUF_BLK2,x
	inx
	dey
	bpl	.1
.2:
	iny
.3:
	lda	<FNC_ARG+1,x
	asl	a
	adc	#BG_LARGE_NUM0A
	sta	VBUF_BLK1,x
	ora	#1
	sta	VBUF_BLK2,x
	inx
	dey
	bpl	.3

	ldx	#LOW(Vcmd_Time1)
	ldy	#HIGH(Vcmd_Time1)
	jsr	Vcmd_SetData

	ldx	#LOW(Vcmd_Time2)
	ldy	#HIGH(Vcmd_Time2)
	jmp	Vcmd_SetData

Vcmd_SetPalette:
	tay
	and	#$0f
	tax
	clc
	lda	#LOW(Pal_Data)
	adc	.offset_l,x
	sta	<FNC_WORK
	lda	#HIGH(Pal_Data)
	adc	.offset_h,x
	sta	<FNC_WORK+1
	tya
	and	#$f0
	sta	<FNC_WORK+2
	ldy	#31
	ldx	#31
.1:
	lda	[FNC_WORK],y
	sec
	sbc	<FNC_WORK+2
	bpl	.2
	lda	#$1d
.2:
	sta	VBUF_BLK2,x
	dey
	dex
	bpl	.1

	ldx	#LOW(Vcmd_Pal)
	ldy	#HIGH(Vcmd_Pal)
	jmp	Vcmd_SetData
.offset_l:
	.db	$00, $20, $40, $60, $80, $a0, $c0, $e0
	.db	$00, $20, $40, $60, $80, $a0, $c0, $e0
.offset_h:
	.db	$00, $00, $00, $00, $00, $00, $00, $00
	.db	$01, $01, $01, $01, $01, $01, $01, $01

Spr_Init:
	lda	#$f0
	sta	SPR_DATA+252
	lda	#$00
	sta	SPR_DATA+253
	sta	SPR_DATA+254
	sta	SPR_DATA+255

	ldx	#$fc
.1:
	lda	#$f0
	sta	SPR_DATA-4,x
	lda	#$00
	sta	SPR_DATA-3,x
	sta	SPR_DATA-2,x
	sta	SPR_DATA-1,x
	lda	Int-4,x
	tax
	bne	.1

	lda	#1
	sta	<SPR_UPD
	rts

Spr_SetCursor:
	lda	<CUR_POS
	and	#$f0
	sta	<FNC_WORK+1
	lsr	a
	and	#$08
	sta	<FNC_WORK
	lda	<CUR_POS
	and	#$0f
	asl	a
	asl	a
	asl	a
;	clc
	adc	<FNC_WORK
	sta	<FNC_WORK

	; XW
	lda	<FNC_WORK
;	clc
	adc	#12
	sta	SPR_DATA+OBJ_CURSOR0*4+3
	sta	SPR_DATA+OBJ_CURSOR2*4+3
;	clc
	adc	#31
	sta	SPR_DATA+OBJ_CURSOR1*4+3
	sta	SPR_DATA+OBJ_CURSOR3*4+3

	; YW
	lda	<FNC_WORK+1
;	clc
	adc	#11
	sta	SPR_DATA+OBJ_CURSOR0*4+0
	sta	SPR_DATA+OBJ_CURSOR1*4+0
;	clc
	adc	#39
	sta	SPR_DATA+OBJ_CURSOR2*4+0
	sta	SPR_DATA+OBJ_CURSOR3*4+0

	; ^Cԍ
	lda	#SPR_CURSOR+1
	sta	SPR_DATA+OBJ_CURSOR0*4+1
	sta	SPR_DATA+OBJ_CURSOR1*4+1
	sta	SPR_DATA+OBJ_CURSOR2*4+1
	sta	SPR_DATA+OBJ_CURSOR3*4+1

	; 
	lda	#$03
	sta	SPR_DATA+OBJ_CURSOR0*4+2
	lda	#$43
	sta	SPR_DATA+OBJ_CURSOR1*4+2
	lda	#$83
	sta	SPR_DATA+OBJ_CURSOR2*4+2
	lda	#$c3
	sta	SPR_DATA+OBJ_CURSOR3*4+2

	lda	#1
	sta	<SPR_UPD
	rts

Spr_ClearCursor:
	ldx	#(OBJ_CURSOR3-OBJ_CURSOR0+1)*4
.1:
	lda	#$f0
	sta	SPR_DATA+OBJ_CURSOR0*4-4,x
	lda	#$00
	sta	SPR_DATA+OBJ_CURSOR0*4-3,x
	sta	SPR_DATA+OBJ_CURSOR0*4-2,x
	sta	SPR_DATA+OBJ_CURSOR0*4-1,x
	lda	Int-4,x
	tax
	bne	.1

	lda	#1
	sta	<SPR_UPD
	rts

Spr_SetGem:
	ldx	#64
.1:
	lda	#$f0
	sta	SPR_DATA+OBJ_GEM0A*4-4,x
	lda	Int-4,x
	tax
	bne	.1

	lda	<USR_CNT
	beq	.20

	ldx	#7
	ldy	#56
.11:
	lda	#$00
	sta	<FNC_WORK
	lda	<GEM_TYPE,x
	beq	.12
	asl	a
	rol	<FNC_WORK
	asl	a
	rol	<FNC_WORK
	eor	#1
	sta	SPR_DATA+OBJ_GEM0A*4+1,y
	eor	#2
	sta	SPR_DATA+OBJ_GEM0B*4+1,y
	lda	<FNC_WORK
	sta	SPR_DATA+OBJ_GEM0A*4+2,y
	sta	SPR_DATA+OBJ_GEM0B*4+2,y
	lda	<GEM_POSY,x
	sta	SPR_DATA+OBJ_GEM0A*4,y
	sta	SPR_DATA+OBJ_GEM0B*4,y
	lda	<GEM_POSX,x
	sta	SPR_DATA+OBJ_GEM0A*4+3,y
;	clc
	adc	#8
	sta	SPR_DATA+OBJ_GEM0B*4+3,y
.12:
	lda	Int-8,y
	tay
	dex
	bpl	.11
.20:
	lda	#1
	sta	<SPR_UPD
	rts

Spr_ClearMessage:
	ldx	#18*4
.1:
	lda	#$f0
	sta	SPR_DATA+OBJ_MESSAGE*4-4,x
	lda	#$00
	sta	SPR_DATA+OBJ_MESSAGE*4-3,x
	sta	SPR_DATA+OBJ_MESSAGE*4-2,x
	sta	SPR_DATA+OBJ_MESSAGE*4-1,x
	lda	Int-4,x
	tax
	bne	.1

	lda	#1
	sta	<SPR_UPD
	rts

Spr_SetReadyMessage:
	ldx	#LOW(.data1)
	ldy	#HIGH(.data1)
	jsr	Spr_SetAlignedObject

	ldx	#LOW(.data2)
	ldy	#HIGH(.data2)
	jsr	Spr_SetAlignedObject

	rts

.data1:
	.db	8, $03, SPR_READY,    OBJ_MESSAGE,   96, 80
.data2:
	.db	8, $03, SPR_READY+16, OBJ_MESSAGE+8, 96, 96

Spr_SetGoMessage:
	ldx	#LOW(.data1)
	ldy	#HIGH(.data1)
	jsr	Spr_SetAlignedObject

	ldx	#LOW(.data2)
	ldy	#HIGH(.data2)
	jsr	Spr_SetAlignedObject

	rts

.data1:
	.db	5, $03, SPR_GO,    OBJ_MESSAGE,   108, 80
.data2:
	.db	5, $03, SPR_GO+12, OBJ_MESSAGE+5, 108, 96

Spr_SetTimeupMessage:
	ldx	#LOW(.data1)
	ldy	#HIGH(.data1)
	jsr	Spr_SetAlignedObject

	ldx	#LOW(.data2)
	ldy	#HIGH(.data2)
	jsr	Spr_SetAlignedObject

	ldx	#LOW(.data3)
	ldy	#HIGH(.data3)
	jsr	Spr_SetAlignedObject

	rts

.data1:
	.db	6, $03, SPR_TIMEUP,    OBJ_MESSAGE,    96,    72
.data2:
	.db	8, $03, SPR_TIMEUP+12, OBJ_MESSAGE+6,  96,    88
.data3:
	.db	4, $03, SPR_TIMEUP+28, OBJ_MESSAGE+14, 96+32, 104


Spr_SetAlignedObject:
	stx	<FNC_WORK
	sty	<FNC_WORK+1

	ldy	#5
.1:
	lda	[FNC_WORK],y
	sta	FNC_WORK+2,y
	dey
	bpl	.1

	lda	<FNC_WORK+5
	asl	a
	asl	a
	sta	<FNC_WORK
	lda	#HIGH(SPR_DATA)
	sta	<FNC_WORK+1

	lda	<FNC_WORK+2
	tax
	dex
	asl	a
	asl	a
	tay
.2:
	txa
	asl	a
	asl	a
	asl	a
;	clc
	adc	<FNC_WORK+6	; XW
	dey
	sta	[FNC_WORK],y

	lda	<FNC_WORK+3	; Agr[g
	dey
	sta	[FNC_WORK],y

	txa
	asl	a
;	clc
	adc	<FNC_WORK+4	; p^[
	eor	#1
	dey
	sta	[FNC_WORK],y

	lda	<FNC_WORK+7	; YW
	dey
	sta	[FNC_WORK],y

	dex
	bpl	.2

	lda	#1
	sta	<SPR_UPD
	rts

Spr_SetTitle:
	ldx	#(.end-.data)
.1:
	lda	.data-1,x
	sta	SPR_DATA+OBJ_GEM0A*4-1,x
	dex
	bpl	.1

	lda	#1
	sta	<SPR_UPD
	rts

.data:
	.db	31+12*8,   SPR_MINI_GEM0B+1, $01,  8*16
	.db	31+12*3,   SPR_MINI_GEM1A+1, $00, 13*16
	.db	31+12*1+8, SPR_MINI_GEM1B+1, $00, 13*16
	.db	31+12*4,   SPR_MINI_GEM3A+1, $01, 10*16+8
	.db	31+12*4,   SPR_MINI_GEM3B+1, $01, 11*16
	.db	31+12*1+4, SPR_MINI_GEM3C+1, $01, 10*16+8
	.db	31+12*1+4, SPR_MINI_GEM3D+1, $01, 11*16
	.db	31+12*2+8, SPR_MINI_GEM3E+1, $01, 10*16+8
	.db	31+12*2+8, SPR_MINI_GEM3F+1, $01, 11*16
	.db	31+12*0+6, SPR_MINI_GEM3A+1, $01, 10*16+8
	.db	31+12*0+6, SPR_MINI_GEM3B+1, $01, 11*16
	.db	31+12*3,   SPR_MINI_GEM3B+1, $01,  6*16
	.db	31+12*0+4, SPR_MINI_GEM3D+1, $01,  6*16
	.db	31+12*1+8, SPR_MINI_GEM3F+1, $01,  6*16
	.db	31+12*0+4, SPR_MINI_GEM3C+1, $01,  4*16+8
	.db	31+12*1+8, SPR_MINI_GEM3E+1, $01,  4*16+8
.end:

Spr_SetTitleCursor:
	ldx	#(.end-.data)
.1:
	lda	.data-1,x
	dex
	sta	SPR_DATA+OBJ_CURSOR0*4,x
	bpl	.1

	lda	<CUR_POS
	beq	.2
	lda	SPR_DATA+OBJ_CURSOR0*4
	clc
	adc	#16
	sta	SPR_DATA+OBJ_CURSOR0*4
	sta	SPR_DATA+OBJ_CURSOR1*4
.2:

	lda	#1
	sta	<SPR_UPD
	rts

.data:
	.db	10*16-3, SPR_MINI_GEM0A+1, $01, 6*16-6
	.db	10*16-3, SPR_MINI_GEM0B+1, $01, 6*16+2
.end:


Time_DecFrame:
	ldx	#4
	lda	<TIME_CNT1
	bit	Int+$fc
	bne	.1
	and	#$03
	ora	<TIME_CNT2
	beq	.2
	ldx	#1
	jsr	Time_SubSecond
	ldx	#20
	lda	<TIME_CNT1
.1:
	sec
	sbc	Int,x
.2:
	sta	<TIME_CNT1
	and	#$fc
	rts

Time_AddSecond:
	lda	<TIME_CNT2
	clc
	adc	Int,x
	sta	<TIME_CNT2
	bcc	.1
	lda	<TIME_CNT1
	ora	#$fc
	cmp	#$ff
	beq	.2
	inc	<TIME_CNT1
.1:
	rts
.2:
	sta	<TIME_CNT2
	rts

Time_SubSecond:
	lda	<TIME_CNT2
	sec
	sbc	Int,x
	sta	<TIME_CNT2
	bcs	.1
	lda	<TIME_CNT1
	and	#$03
	beq	.2
	dec	<TIME_CNT1
.1:
	rts
.2:
	sta	<TIME_CNT2
	rts

PlayNextBgm:
	inc	<CUR_BGM
PlayCurrentBgm:
	lda	<CUR_BGM
	asl	a
	cmp	#(.bgm_end-.bgm+1)
	bcs	.1
	tax
	lda	.bgm-2,x
	ldy	.bgm-1,x
	tax
	jmp	SoundDriver_PlayBGM_Ex
.1:
	lda	#0
	sta	<CUR_BGM
	jmp	SoundDriver_StopBGM
.bgm:
;	.dw	Bgm1_PlayData
	.dw	BgmPolka_PlayData
	.dw	BgmTrepark_PlayData
	.dw	BgmInadahime_PlayData
.bgm_end:

PlaySeVanish:
	cpx	#20
	bcc	.1
	ldx	#19
.1:
	lda	.offset_l,x
	ldy	.offset_h,x
	tax
	jmp	SoundDriver_PlaySE_Ex
;	jsr	SoundDriver_PlaySE_Ex
;	rts
.offset_l:
	.db	LOW(SeVanish01_PlayData)
	.db	LOW(SeVanish02_PlayData)
	.db	LOW(SeVanish03_PlayData)
	.db	LOW(SeVanish04_PlayData)
	.db	LOW(SeVanish05_PlayData)
	.db	LOW(SeVanish06_PlayData)
	.db	LOW(SeVanish07_PlayData)
	.db	LOW(SeVanish08_PlayData)
	.db	LOW(SeVanish09_PlayData)
	.db	LOW(SeVanish10_PlayData)
	.db	LOW(SeVanish11_PlayData)
	.db	LOW(SeVanish12_PlayData)
	.db	LOW(SeVanish13_PlayData)
	.db	LOW(SeVanish14_PlayData)
	.db	LOW(SeVanish15_PlayData)
	.db	LOW(SeVanish16_PlayData)
	.db	LOW(SeVanish17_PlayData)
	.db	LOW(SeVanish18_PlayData)
	.db	LOW(SeVanish19_PlayData)
	.db	LOW(SeVanish20_PlayData)
.offset_h:
	.db	HIGH(SeVanish01_PlayData)
	.db	HIGH(SeVanish02_PlayData)
	.db	HIGH(SeVanish03_PlayData)
	.db	HIGH(SeVanish04_PlayData)
	.db	HIGH(SeVanish05_PlayData)
	.db	HIGH(SeVanish06_PlayData)
	.db	HIGH(SeVanish07_PlayData)
	.db	HIGH(SeVanish08_PlayData)
	.db	HIGH(SeVanish09_PlayData)
	.db	HIGH(SeVanish10_PlayData)
	.db	HIGH(SeVanish11_PlayData)
	.db	HIGH(SeVanish12_PlayData)
	.db	HIGH(SeVanish13_PlayData)
	.db	HIGH(SeVanish14_PlayData)
	.db	HIGH(SeVanish15_PlayData)
	.db	HIGH(SeVanish16_PlayData)
	.db	HIGH(SeVanish17_PlayData)
	.db	HIGH(SeVanish18_PlayData)
	.db	HIGH(SeVanish19_PlayData)
	.db	HIGH(SeVanish20_PlayData)

